"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrdtEncoder = void 0;
const EncoderFull_1 = require("../../../json-pack/EncoderFull");
class CrdtEncoder extends EncoderFull_1.EncoderFull {
    id(x, y) {
        if (x <= 0b111 && y <= 0b1111) {
            this.u8((x << 4) | y);
        }
        else {
            this.b1vuint28(true, x);
            this.vuint39(y);
        }
    }
    vuint57(num) {
        if (num <= 0b1111111) {
            this.u8(num);
        }
        else if (num <= 16383) {
            this.u8(0b10000000 | (num & 0b01111111));
            this.u8(num >>> 7);
        }
        else if (num <= 2097151) {
            this.u8(0b10000000 | (num & 0b01111111));
            this.u8(0b10000000 | ((num >>> 7) & 0b01111111));
            this.u8(num >>> 14);
        }
        else if (num <= 268435455) {
            this.u8(0b10000000 | (num & 0b01111111));
            this.u8(0b10000000 | ((num >>> 7) & 0b01111111));
            this.u8(0b10000000 | ((num >>> 14) & 0b01111111));
            this.u8(num >>> 21);
        }
        else {
            let lo32 = num | 0;
            if (lo32 < 0)
                lo32 += 4294967296;
            const hi32 = (num - lo32) / 4294967296;
            if (num <= 34359738367) {
                this.u8(0b10000000 | (num & 0b01111111));
                this.u8(0b10000000 | ((num >>> 7) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 14) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 21) & 0b01111111));
                this.u8((hi32 << 4) | (num >>> 28));
            }
            else if (num <= 4398046511103) {
                this.u8(0b10000000 | (num & 0b01111111));
                this.u8(0b10000000 | ((num >>> 7) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 14) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 21) & 0b01111111));
                this.u8(0b10000000 | ((hi32 & 0b111) << 4) | (num >>> 28));
                this.u8(hi32 >>> 3);
            }
            else if (num <= 562949953421311) {
                this.u8(0b10000000 | (num & 0b01111111));
                this.u8(0b10000000 | ((num >>> 7) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 14) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 21) & 0b01111111));
                this.u8(0b10000000 | ((hi32 & 0b111) << 4) | (num >>> 28));
                this.u8(0b10000000 | ((hi32 & 1016) >>> 3));
                this.u8(hi32 >>> 10);
            }
            else {
                this.u8(0b10000000 | (num & 0b01111111));
                this.u8(0b10000000 | ((num >>> 7) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 14) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 21) & 0b01111111));
                this.u8(0b10000000 | ((hi32 & 0b111) << 4) | (num >>> 28));
                this.u8(0b10000000 | ((hi32 & 1016) >>> 3));
                this.u8(0b10000000 | ((hi32 & 130048) >>> 10));
                this.u8(hi32 >>> 17);
            }
        }
    }
    vuint39(num) {
        if (num <= 0b1111111) {
            this.u8(num);
        }
        else if (num <= 16383) {
            this.u8(0b10000000 | (num & 0b01111111));
            this.u8(num >>> 7);
        }
        else if (num <= 2097151) {
            this.u8(0b10000000 | (num & 0b01111111));
            this.u8(0b10000000 | ((num >>> 7) & 0b01111111));
            this.u8(num >>> 14);
        }
        else if (num <= 268435455) {
            this.u8(0b10000000 | (num & 0b01111111));
            this.u8(0b10000000 | ((num >>> 7) & 0b01111111));
            this.u8(0b10000000 | ((num >>> 14) & 0b01111111));
            this.u8(num >>> 21);
        }
        else {
            let lo32 = num | 0;
            if (lo32 < 0)
                lo32 += 4294967296;
            const hi32 = (num - lo32) / 4294967296;
            if (num <= 34359738367) {
                this.u8(0b10000000 | (num & 0b01111111));
                this.u8(0b10000000 | ((num >>> 7) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 14) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 21) & 0b01111111));
                this.u8((hi32 << 4) | (num >>> 28));
            }
            else if (num <= 4398046511103) {
                this.u8(0b10000000 | (num & 0b01111111));
                this.u8(0b10000000 | ((num >>> 7) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 14) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 21) & 0b01111111));
                this.u8(0b10000000 | ((hi32 & 0b111) << 4) | (num >>> 28));
                this.u8((hi32 >>> 3) & 0b1111);
            }
        }
    }
    b1vuint56(flag, num) {
        if (num <= 0b111111) {
            this.u8((flag ? 0b10000000 : 0b00000000) | num);
        }
        else {
            const firstByteMask = flag ? 0b11000000 : 0b01000000;
            if (num <= 8191) {
                this.u8(firstByteMask | (num & 0b00111111));
                this.u8(num >>> 6);
            }
            else if (num <= 1048575) {
                this.u8(firstByteMask | (num & 0b00111111));
                this.u8(0b10000000 | ((num >>> 6) & 0b01111111));
                this.u8(num >>> 13);
            }
            else if (num <= 134217727) {
                this.u8(firstByteMask | (num & 0b00111111));
                this.u8(0b10000000 | ((num >>> 6) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 13) & 0b01111111));
                this.u8(num >>> 20);
            }
            else {
                let lo32 = num | 0;
                if (lo32 < 0)
                    lo32 += 4294967296;
                const hi32 = (num - lo32) / 4294967296;
                if (num <= 17179869183) {
                    this.u8(firstByteMask | (num & 0b00111111));
                    this.u8(0b10000000 | ((num >>> 6) & 0b01111111));
                    this.u8(0b10000000 | ((num >>> 13) & 0b01111111));
                    this.u8(0b10000000 | ((num >>> 20) & 0b01111111));
                    this.u8((hi32 << 5) | (num >>> 27));
                }
                else if (num <= 2199023255551) {
                    this.u8(firstByteMask | (num & 0b00111111));
                    this.u8(0b10000000 | ((num >>> 6) & 0b01111111));
                    this.u8(0b10000000 | ((num >>> 13) & 0b01111111));
                    this.u8(0b10000000 | ((num >>> 20) & 0b01111111));
                    this.u8(0b10000000 | ((hi32 & 0b11) << 5) | (num >>> 27));
                    this.u8(hi32 >>> 2);
                }
                else if (num <= 281474976710655) {
                    this.u8(firstByteMask | (num & 0b00111111));
                    this.u8(0b10000000 | ((num >>> 6) & 0b01111111));
                    this.u8(0b10000000 | ((num >>> 13) & 0b01111111));
                    this.u8(0b10000000 | ((num >>> 20) & 0b01111111));
                    this.u8(0b10000000 | ((hi32 & 0b11) << 5) | (num >>> 27));
                    this.u8(0b10000000 | ((hi32 & 508) >>> 2));
                    this.u8(hi32 >>> 9);
                }
                else {
                    this.u8(firstByteMask | (num & 0b00111111));
                    this.u8(0b10000000 | ((num >>> 6) & 0b01111111));
                    this.u8(0b10000000 | ((num >>> 13) & 0b01111111));
                    this.u8(0b10000000 | ((num >>> 20) & 0b01111111));
                    this.u8(0b10000000 | ((hi32 & 0b11) << 5) | (num >>> 27));
                    this.u8(0b10000000 | ((hi32 & 508) >>> 2));
                    this.u8(0b10000000 | ((hi32 & 65024) >>> 9));
                    this.u8(hi32 >>> 16);
                }
            }
        }
    }
    b1vuint28(flag, num) {
        if (num <= 0b111111) {
            this.u8((flag ? 0b10000000 : 0b00000000) | num);
        }
        else {
            const firstByteMask = flag ? 0b11000000 : 0b01000000;
            if (num <= 8191) {
                this.u8(firstByteMask | (num & 0b00111111));
                this.u8(num >>> 6);
            }
            else if (num <= 1048575) {
                this.u8(firstByteMask | (num & 0b00111111));
                this.u8(0b10000000 | ((num >>> 6) & 0b01111111));
                this.u8(num >>> 13);
            }
            else {
                this.u8(firstByteMask | (num & 0b00111111));
                this.u8(0b10000000 | ((num >>> 6) & 0b01111111));
                this.u8(0b10000000 | ((num >>> 13) & 0b01111111));
                this.u8(num >>> 20);
            }
        }
    }
    uint53vuint39(x, z) {
        let x1 = x | 0;
        if (x1 < 0)
            x1 += 4294967296;
        const x2 = (x - x1) / 4294967296;
        this.u32(x1);
        this.u16(x2 & 0xffff);
        const fiveXBits = (x2 >>> 16) << 3;
        const twoZBits = (z >>> 8) & 0b11;
        const zFitsIn10Bits = z <= 1023;
        this.u8(fiveXBits | (zFitsIn10Bits ? 0b000 : 0b100) | twoZBits);
        this.u8(z & 0xff);
        if (zFitsIn10Bits)
            return;
        if (z <= 131071) {
            this.u8(z >>> 10);
        }
        else if (z <= 16777215) {
            this.u8(128 | ((z >>> 10) & 127));
            this.u8(z >>> 17);
        }
        else if (z <= 2147483647) {
            this.u8(128 | ((z >>> 10) & 127));
            this.u8(128 | ((z >>> 17) & 127));
            this.u8(z >>> 24);
        }
        else {
            let z1 = z | 0;
            if (z1 < 0)
                z1 += 4294967296;
            const z2 = (z - z1) / 4294967296;
            this.u8(128 | ((z1 >>> 10) & 127));
            this.u8(128 | ((z1 >>> 17) & 127));
            this.u8(128 | ((z1 >>> 24) & 127));
            this.u8((z1 >>> 31) | (z2 << 1));
        }
    }
}
exports.CrdtEncoder = CrdtEncoder;
