import { ArrayType } from '../../types/rga-array/ArrayType';
import { BinaryType } from '../../types/rga-binary/BinaryType';
import { ClockDecoder } from '../../../json-crdt-patch/codec/clock/ClockDecoder';
import { ConstantType } from '../../types/const/ConstantType';
import { ITimestamp } from '../../../json-crdt-patch/clock';
import { JsonNode } from '../../types';
import { Model } from '../../model';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { StringType } from '../../types/rga-string/StringType';
import { ValueType } from '../../types/lww-value/ValueType';
export declare class Decoder {
    protected time?: number;
    protected clockDecoder?: ClockDecoder;
    decode(data: unknown[]): Model;
    protected ts(arr: unknown[], index: number): [ITimestamp, number];
    protected decodeNode(doc: Model, data: unknown): JsonNode;
    protected decodeObj(doc: Model, data: unknown[]): ObjectType;
    protected decodeArr(doc: Model, data: unknown[]): ArrayType;
    protected decodeStr(doc: Model, data: unknown[]): StringType;
    protected decodeBin(doc: Model, data: unknown[]): BinaryType;
    protected decodeVal(doc: Model, data: unknown[]): ValueType;
    protected decodeConst(doc: Model, data: unknown[]): ConstantType;
}
