import { ITimestamp } from '../../../json-crdt-patch/clock';
import { SetObjectKeysOperation } from '../../../json-crdt-patch/operations/SetObjectKeysOperation';
import { Model } from '../../model';
import { JsonNode } from '../../types';
import { ObjectChunk } from './ObjectChunk';
export declare class ObjectType implements JsonNode {
    readonly doc: Model;
    readonly id: ITimestamp;
    readonly latest: Map<string, ObjectChunk>;
    constructor(doc: Model, id: ITimestamp);
    get(key: string): undefined | ITimestamp;
    getId(key: string): undefined | ITimestamp;
    getNode(key: string): undefined | JsonNode;
    insert(op: SetObjectKeysOperation): void;
    put(key: string, id: ITimestamp, value: ITimestamp): void;
    putChunk(key: string, chunk: ObjectChunk): void;
    private _toJson;
    toJson(): Readonly<Record<string, unknown>>;
    toString(tab?: string): string;
    clone(doc: Model): ObjectType;
    children(): IterableIterator<ITimestamp>;
}
