import { BinaryChunk } from './BinaryChunk';
import { DeleteOperation } from '../../../json-crdt-patch/operations/DeleteOperation';
import { InsertBinaryDataOperation } from '../../../json-crdt-patch/operations/InsertBinaryDataOperation';
import { ITimestamp, ITimespan } from '../../../json-crdt-patch/clock';
import type { JsonNode } from '../../types';
import type { Model } from '../../model';
export declare class BinaryType implements JsonNode {
    readonly doc: Model;
    readonly id: ITimestamp;
    start: BinaryChunk;
    end: BinaryChunk;
    constructor(doc: Model, id: ITimestamp);
    onInsert(op: InsertBinaryDataOperation): void;
    onDelete(op: DeleteOperation): void;
    private insertChunk;
    private splitChunk;
    private deleteInChunk;
    findId(index: number): ITimestamp;
    findIdSpan(index: number, length: number): ITimespan[];
    append(chunk: BinaryChunk): void;
    private _toJson?;
    toJson(): Uint8Array;
    clone(doc: Model): BinaryType;
    children(): IterableIterator<ITimestamp>;
    chunks(): IterableIterator<BinaryChunk>;
    size(): number;
    length(): number;
    toString(tab?: string): string;
}
