"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EncoderFull = void 0;
const isUint8Array_1 = require("../../util/isUint8Array");
const v4_1 = require("../Encoder/v4");
const JsonPackExtension_1 = require("../JsonPackExtension");
const JsonPackValue_1 = require("../JsonPackValue");
class EncoderFull extends v4_1.Encoder {
    encodeAny(json) {
        switch (json) {
            case null:
                return this.u8(0xc0);
            case false:
                return this.u8(0xc2);
            case true:
                return this.u8(0xc3);
        }
        if (json instanceof Array)
            return this.encodeArray(json);
        switch (typeof json) {
            case 'number':
                return this.encodeNumber(json);
            case 'string':
                return this.encodeString(json);
            case 'object': {
                if (json instanceof JsonPackValue_1.JsonPackValue)
                    return this.buf(json.buf, json.buf.byteLength);
                if (json instanceof JsonPackExtension_1.JsonPackExtension)
                    return this.encodeExt(json);
                if ((0, isUint8Array_1.isUint8Array)(json))
                    return this.encodeBinary(json);
                return this.encodeObject(json);
            }
        }
    }
}
exports.EncoderFull = EncoderFull;
