import type { CompactMoveOp } from '../codec/compact/types';
import { AbstractOp } from './AbstractOp';
import { OperationMove } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from '../constants';
import { IMessagePackEncoder } from '../../json-pack/Encoder/types';
export declare class OpMove extends AbstractOp<'move'> {
    readonly from: Path;
    constructor(path: Path, from: Path);
    op(): "move";
    code(): OPCODE;
    apply(doc: unknown): {
        doc: unknown;
        old: any;
    };
    toJson(parent?: AbstractOp): OperationMove;
    toCompact(parent: undefined | AbstractOp, verbose: boolean): CompactMoveOp;
    encode(encoder: IMessagePackEncoder, parent?: AbstractOp): void;
}
