"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryRequestErrorMessage = void 0;
const header_1 = require("../../codec/binary/header");
const nominal_1 = require("../nominal");
class BinaryRequestErrorMessage extends nominal_1.RequestErrorMessage {
    size() {
        const dataSize = this.data.byteLength;
        return (0, header_1.getHeaderSize)(dataSize) + 2 + 1 + this.method.length + dataSize;
    }
    writeCompact(encoder) {
        const data = this.data;
        const dataSize = data ? data.byteLength : 0;
        if (!dataSize) {
            encoder.encodeArrayHeader(3);
            encoder.encodeUnsignedInteger(this.id);
            encoder.u8(1);
            encoder.encodeAsciiString(this.method);
            return;
        }
        encoder.encodeArrayHeader(4);
        encoder.encodeUnsignedInteger(this.id);
        encoder.u8(1);
        encoder.encodeAsciiString(this.method);
        encoder.buf(data, dataSize);
    }
}
exports.BinaryRequestErrorMessage = BinaryRequestErrorMessage;
