"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryResponseDataMessage = void 0;
const header_1 = require("../../codec/binary/header");
const nominal_1 = require("../nominal");
class BinaryResponseDataMessage extends nominal_1.ResponseDataMessage {
    size() {
        const dataSize = this.data.byteLength;
        return (0, header_1.getHeaderSize)(dataSize) + 2 + dataSize;
    }
    writeCompact(encoder) {
        const data = this.data;
        encoder.encodeArrayHeader(3);
        encoder.encodeUnsignedInteger(-2);
        encoder.encodeUnsignedInteger(this.id);
        encoder.buf(data, data.byteLength);
    }
}
exports.BinaryResponseDataMessage = BinaryResponseDataMessage;
