"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonRequestCompleteMessage = void 0;
const nominal_1 = require("../nominal");
class JsonRequestCompleteMessage extends nominal_1.RequestCompleteMessage {
    toValue() {
        return this.data ? JSON.parse(this.data) : undefined;
    }
    toCompact() {
        const value = this.toValue();
        return value === undefined ? [this.id, this.method] : [this.id, this.method, value];
    }
    toCompactJson() {
        if (this.data)
            return ('[' + this.id + ',"' + this.method + '",' + this.data + ']');
        return ('[' + this.id + ',"' + this.method + '"]');
    }
}
exports.JsonRequestCompleteMessage = JsonRequestCompleteMessage;
