"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonRequestDataMessage = void 0;
const nominal_1 = require("../nominal");
class JsonRequestDataMessage extends nominal_1.RequestDataMessage {
    toValue() {
        return this.data === undefined ? undefined : JSON.parse(this.data);
    }
    toCompact() {
        const value = this.toValue();
        return value === undefined ? [this.id, 0, this.method] : [this.id, 0, this.method, value];
    }
    toCompactJson() {
        const data = this.data;
        if (data === undefined)
            return ('[' + this.id + ',0,"' + this.method + '",' + data + ']');
        return ('[' + this.id + ',0,"' + this.method + '"]');
    }
}
exports.JsonRequestDataMessage = JsonRequestDataMessage;
