import { Observable } from 'rxjs';
import { ReactiveRpcMessage } from '../messages/nominal';
import { RpcClient } from './RpcClient';
import { RpcServer } from './RpcServer';
export interface RpcDuplexParams<Ctx = unknown, T = unknown> {
    client: RpcClient<T>;
    server: RpcServer<Ctx>;
}
export declare class RpcDuplex<Ctx = unknown, T = unknown> {
    readonly client: RpcClient<T>;
    readonly server: RpcServer<Ctx>;
    constructor(params: RpcDuplexParams<Ctx, T>);
    onMessages(messages: ReactiveRpcMessage<T>[], ctx: Ctx): void;
    onMessage(message: ReactiveRpcMessage<T>, ctx: Ctx): void;
    call$(method: string, data: T): Observable<T>;
    call$(method: string, data: Observable<T>): Observable<T>;
    call(method: string, data: T): Promise<T>;
    notify(method: string, data: undefined | T): void;
    stop(): void;
    disconnect(): void;
}
