"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RpcServerJson = void 0;
const RpcServer_1 = require("./RpcServer");
const json_brand_1 = require("../../../json-brand");
const JsonNotificationMessage_1 = require("../messages/json/JsonNotificationMessage");
const JsonRequestUnsubscribeMessage_1 = require("../messages/json/JsonRequestUnsubscribeMessage");
const JsonResponseCompleteMessage_1 = require("../messages/json/JsonResponseCompleteMessage");
const JsonResponseDataMessage_1 = require("../messages/json/JsonResponseDataMessage");
const JsonResponseErrorMessage_1 = require("../messages/json/JsonResponseErrorMessage");
const stringify = json_brand_1.JSON.stringify;
class RpcServerJson extends RpcServer_1.RpcServer {
    notifMessage(method, data) {
        return new JsonNotificationMessage_1.JsonNotificationMessage(method, stringify(data));
    }
    resCompleteMessage(id, data) {
        return new JsonResponseCompleteMessage_1.JsonResponseCompleteMessage(id, data);
    }
    resDataMessage(id, data) {
        return new JsonResponseDataMessage_1.JsonResponseDataMessage(id, data);
    }
    resErrorMessage(id, data) {
        return new JsonResponseErrorMessage_1.JsonResponseErrorMessage(id, stringify(data));
    }
    reqUnsubscribeMessage(id) {
        return new JsonRequestUnsubscribeMessage_1.JsonRequestUnsubscribeMessage(id);
    }
    createStaticCall(name, request, ctx) {
        return this.caller.callJson(name, request, ctx);
    }
    createCall(name, ctx) {
        const streamCallback = (method, ctx, req$) => method.callJson$(ctx, req$);
        return this.caller.createCall(name, ctx, (name, req, ctx) => this.caller.callJson(name, req, ctx), streamCallback);
    }
}
exports.RpcServerJson = RpcServerJson;
