"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RpcServerMsgPack = void 0;
const RpcServer_1 = require("./RpcServer");
const binary_1 = require("../messages/binary");
const util_1 = require("../../../json-pack/util");
class RpcServerMsgPack extends RpcServer_1.RpcServer {
    notifMessage(method, data) {
        return new binary_1.BinaryNotificationMessage(method, (0, util_1.encodeFull)(data));
    }
    resCompleteMessage(id, data) {
        return new binary_1.BinaryResponseCompleteMessage(id, data);
    }
    resDataMessage(id, data) {
        return new binary_1.BinaryResponseDataMessage(id, data);
    }
    resErrorMessage(id, data) {
        return new binary_1.BinaryResponseErrorMessage(id, (0, util_1.encodeFull)(data));
    }
    reqUnsubscribeMessage(id) {
        return new binary_1.BinaryRequestUnsubscribeMessage(id);
    }
    createStaticCall(name, request, ctx) {
        return this.caller.callMsgPack(name, request, ctx);
    }
    createCall(name, ctx) {
        const streamCallback = (method, ctx, req$) => method.callMsgPack$(ctx, req$);
        return this.caller.createCall(name, ctx, (name, req, ctx) => this.caller.callMsgPack(name, req, ctx), streamCallback);
    }
}
exports.RpcServerMsgPack = RpcServerMsgPack;
