import { RpcServerError } from './constants';
export interface ErrorFormatter<E = unknown> {
    format(error: E | Error | unknown): E;
    formatValidation(error: E | Error | unknown): E;
    formatCode(code: RpcServerError): E;
}
export interface ErrorLike {
    message: string;
    status?: number;
    code?: string;
    errno?: number;
    errorId?: string;
}
export declare const formatErrorLike: (error: ErrorLike) => ErrorLike;
export declare const isErrorLike: (error: unknown) => error is ErrorLike;
export declare const formatError: (error: unknown) => ErrorLike;
export declare const formatErrorCode: (errno: number) => ErrorLike;
export declare class ErrorLikeErrorFormatter implements ErrorFormatter<ErrorLike> {
    format(error: ErrorLike | Error | unknown): ErrorLike;
    formatValidation(error: ErrorLike | Error | unknown): ErrorLike;
    formatCode(code: RpcServerError): ErrorLike;
}
export declare class RpcError extends Error implements ErrorLike {
    readonly errno: RpcServerError;
    readonly code: string;
    constructor(errno: RpcServerError, message?: string);
}
