"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeSseAndNdjsonHeaders = exports.parsePayload = void 0;
const parsePayload = (ctx, payload) => {
    if (typeof payload === 'string') {
        ctx.payloadSize = payload.length;
        return JSON.parse(payload || 'null');
    }
    else {
        ctx.payloadSize = payload.byteLength;
        const str = payload.toString('utf8') || 'null';
        return JSON.parse(str);
    }
};
exports.parsePayload = parsePayload;
const AccessControlAllowOrigin = Buffer.from('Access-Control-Allow-Origin');
const AccessControlAllowOriginAllowAll = Buffer.from('*');
const AccessControlAllowCredentials = Buffer.from('Access-Control-Allow-Credentials');
const AccessControlAllowCredentialsTrue = Buffer.from('true');
const ContentType = Buffer.from('Content-Type');
const ContentTypeTextEventStream = Buffer.from('text/event-stream');
const CacheControl = Buffer.from('Cache-Control');
const CacheControlNoCache = Buffer.from('no-cache');
const Connection = Buffer.from('Connection');
const ConnectionKeepAlive = Buffer.from('keep-alive');
const writeSseAndNdjsonHeaders = (res, origin) => {
    if (origin) {
        res.writeHeader(AccessControlAllowOrigin, AccessControlAllowOriginAllowAll);
        res.writeHeader(AccessControlAllowCredentials, AccessControlAllowCredentialsTrue);
    }
    res.writeHeader(ContentType, ContentTypeTextEventStream);
    res.writeHeader(CacheControl, CacheControlNoCache);
    res.writeHeader(Connection, ConnectionKeepAlive);
};
exports.writeSseAndNdjsonHeaders = writeSseAndNdjsonHeaders;
