"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.readBody = void 0;
const MAX_BODY_SIZE = 1024 * 1024;
const readBody = (res, cb) => {
    let buffer;
    res.onData((ab, isLast) => {
        const chunk = Buffer.from(ab);
        buffer = Buffer.concat(buffer ? [buffer, chunk] : [chunk]);
        if (buffer.length > MAX_BODY_SIZE)
            res.end('too large');
        if (isLast)
            cb(buffer);
    });
};
exports.readBody = readBody;
