"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const fs_1 = require("fs");
const json_pack_1 = require("../json-pack");
const JSONB = (0, tslib_1.__importStar)(require("../json-binary"));
try {
    const encoder = new json_pack_1.EncoderFull();
    const buf = (0, fs_1.readFileSync)(0);
    const doc = JSONB.parse(buf.toString());
    const encoded = encoder.encode(doc);
    process.stdout.write(encoded);
}
catch (error) {
    const output = error instanceof Error ? error.message : String(error);
    process.stderr.write(output + '\n');
    process.exit(1);
}
