"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const fs_1 = require("fs");
const json_pack_1 = require("../json-pack");
const JSONB = (0, tslib_1.__importStar)(require("../json-binary"));
try {
    const decoder = new json_pack_1.Decoder();
    const buf = (0, fs_1.readFileSync)(0);
    const arr = new Uint8Array(buf.byteLength);
    for (let i = 0; i < buf.byteLength; i++)
        arr[i] = buf[i];
    const decoded = decoder.decode(arr);
    const json = JSONB.stringify(decoded);
    process.stdout.write(json);
}
catch (error) {
    const output = error instanceof Error ? error.message : String(error);
    process.stderr.write(output + '\n');
    process.exit(1);
}
