import { ArrayChunk } from '../../types/rga-array/ArrayChunk';
import { ArrayType } from '../../types/rga-array/ArrayType';
import { BinaryChunk } from '../../types/rga-binary/BinaryChunk';
import { BinaryType } from '../../types/rga-binary/BinaryType';
import { ConstantType } from '../../types/const/ConstantType';
import { ITimestamp, LogicalVectorClock } from '../../../json-crdt-patch/clock';
import { JsonNode } from '../../types';
import { Model } from '../../model';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { StringChunk } from '../../types/rga-string/StringChunk';
import { StringType } from '../../types/rga-string/StringType';
import { ValueType } from '../../types/lww-value/ValueType';
import { RootJsonCrdtNode, JsonCrdtNode, ObjectJsonCrdtNode, ArrayJsonCrdtNode, ArrayJsonCrdtChunk, JsonCrdtRgaTombstone, ValueJsonCrdtNode, StringJsonCrdtNode, StringJsonCrdtChunk, ConstantJsonCrdtNode, BinaryJsonCrdtNode, BinaryJsonCrdtChunk, JsonCrdtSnapshot, JsonCrdtLogicalTimestamp, JsonCrdtTimestamp } from './types';
export declare class Decoder {
    decode({ time, root }: JsonCrdtSnapshot): Model;
    protected decodeClock(timestamps: JsonCrdtLogicalTimestamp[]): LogicalVectorClock;
    protected decodeTimestamp(ts: JsonCrdtTimestamp): ITimestamp;
    protected decodeRoot(doc: Model, { id, node }: RootJsonCrdtNode): void;
    protected decodeNode(doc: Model, node: JsonCrdtNode): JsonNode;
    protected decodeObj(doc: Model, node: ObjectJsonCrdtNode): ObjectType;
    protected decodeArr(doc: Model, node: ArrayJsonCrdtNode): ArrayType;
    protected decodeArrChunk(doc: Model, c: ArrayJsonCrdtChunk | JsonCrdtRgaTombstone): ArrayChunk;
    protected decodeStr(doc: Model, node: StringJsonCrdtNode): StringType;
    protected decodeStrChunk(doc: Model, c: StringJsonCrdtChunk | JsonCrdtRgaTombstone): StringChunk;
    protected decodeBin(doc: Model, node: BinaryJsonCrdtNode): BinaryType;
    protected decodeBinChunk(doc: Model, c: BinaryJsonCrdtChunk | JsonCrdtRgaTombstone): BinaryChunk;
    protected decodeVal(doc: Model, node: ValueJsonCrdtNode): ValueType;
    protected decodeConst(doc: Model, node: ConstantJsonCrdtNode): ConstantType;
}
