"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValueType = void 0;
class ValueType {
    constructor(id, writeId, value) {
        this.id = id;
        this.writeId = writeId;
        this.value = value;
    }
    insert(op) {
        if (op.id.compare(this.writeId) <= 0)
            return;
        this.writeId = op.id;
        this.value = op.value;
    }
    toJson() {
        return this.value;
    }
    toString(tab = '') {
        return `${tab}${this.constructor.name}(${this.id.toDisplayString()}) { ${this.toJson()} }`;
    }
    clone(doc) {
        const copy = new ValueType(this.id, this.writeId, this.value);
        doc.nodes.index(copy);
        return copy;
    }
    *children() { }
}
exports.ValueType = ValueType;
