import type { JsonNode } from '../../types';
import type { Model } from '../../model';
import { ITimespan, ITimestamp } from '../../../json-crdt-patch/clock';
import { DeleteOperation } from '../../../json-crdt-patch/operations/DeleteOperation';
import { InsertArrayElementsOperation } from '../../../json-crdt-patch/operations/InsertArrayElementsOperation';
import { ArrayChunk } from './ArrayChunk';
export declare class ArrayType implements JsonNode {
    readonly doc: Model;
    readonly id: ITimestamp;
    start: ArrayChunk;
    end: ArrayChunk;
    constructor(doc: Model, id: ITimestamp);
    insert(op: InsertArrayElementsOperation): void;
    private insertChunk;
    private splitChunk;
    delete(op: DeleteOperation): void;
    private deleteInChunk;
    findId(index: number): ITimestamp;
    findValue(index: number): ITimestamp;
    findIdSpans(index: number, length: number): ITimespan[];
    append(chunk: ArrayChunk): void;
    private _toJson;
    toJson(): readonly unknown[];
    clone(model: Model): ArrayType;
    children(): IterableIterator<ITimestamp>;
    chunks(): IterableIterator<ArrayChunk>;
    size(): number;
    length(): number;
    toString(tab?: string): string;
}
