export declare type ExprGet = [fn: '=' | 'get', path: unknown, def?: unknown];
export declare type ExprEquals = [fn: '==' | 'eq', expr1: unknown, expr2: unknown];
export declare type ExprNotEquals = [fn: '!=' | 'ne', expr1: unknown, expr2: unknown];
export declare type ExprIf = [fn: '?' | 'if', test: unknown, then: unknown, els: unknown];
export declare type ExprAnd = [fn: '&&' | 'and', ...expressions: unknown[]];
export declare type ExprOr = [fn: '||' | 'or', ...expressions: unknown[]];
export declare type ExprNot = [fn: '!' | 'not', expression: unknown];
export declare type ExprType = [fn: 'type', expression: unknown];
export declare type ExprBool = [fn: 'bool', expression: unknown];
export declare type ExprNum = [fn: 'num', expression: unknown];
export declare type ExprInt = [fn: 'int', expression: unknown];
export declare type ExprStr = [fn: 'str', expression: unknown];
export declare type ExprStarts = [fn: 'starts', outer: unknown, inner: unknown];
export declare type ExprContains = [fn: 'contains', outer: unknown, inner: unknown];
export declare type ExprEnds = [fn: 'ends', outer: unknown, inner: unknown];
export declare type ExprDefined = [fn: 'defined', path: unknown];
export declare type ExprIn = [fn: 'in', what: unknown, list: unknown];
export declare type ExprMatches = [fn: 'matches', subject: unknown, pattern: string];
export declare type ExprCat = [fn: '.' | 'cat', ...expressions: unknown[]];
export declare type ExprSubstr = [fn: 'substr', str: unknown, from: unknown, length?: unknown];
export declare type ExprLessThan = [fn: '<', expr1: unknown, expr2: unknown];
export declare type ExprLessThanOrEqual = [fn: '<=', expr1: unknown, expr2: unknown];
export declare type ExprGreaterThan = [fn: '>', expr1: unknown, expr2: unknown];
export declare type ExprGreaterThanOrEqual = [fn: '>=', expr1: unknown, expr2: unknown];
export declare type ExprBetweenNeNe = [fn: '><', what: unknown, min: unknown, max: unknown];
export declare type ExprBetweenEqNe = [fn: '=><', what: unknown, min: unknown, max: unknown];
export declare type ExprBetweenNeEq = [fn: '><=', what: unknown, min: unknown, max: unknown];
export declare type ExprBetweenEqEq = [fn: '=><=', what: unknown, min: unknown, max: unknown];
export declare type ExprMin = [fn: 'min', ...expressions: unknown[]];
export declare type ExprMax = [fn: 'max', ...expressions: unknown[]];
export declare type ExprPlus = [fn: '+', ...expressions: unknown[]];
export declare type ExprMinus = [fn: '-', ...expressions: unknown[]];
export declare type ExprAsterisk = [fn: '*', ...expressions: unknown[]];
export declare type ExprSlash = [fn: '/', expr1: unknown, expr2: unknown];
export declare type ExprMod = [fn: '%' | 'mod', expr1: unknown, expr2: unknown];
export declare type ExprRound = [fn: 'round', expr: unknown];
export declare type ExprCeil = [fn: 'ceil', expr: unknown];
export declare type ExprFloor = [fn: 'floor', expr: unknown];
export declare type Expr = ExprGet | ExprEquals | ExprNotEquals | ExprIf | ExprAnd | ExprOr | ExprNot | ExprType | ExprBool | ExprNum | ExprInt | ExprStr | ExprStarts | ExprContains | ExprEnds | ExprDefined | ExprIn | ExprMatches | ExprMatches | ExprCat | ExprSubstr | ExprLessThan | ExprLessThanOrEqual | ExprGreaterThan | ExprGreaterThanOrEqual | ExprBetweenNeNe | ExprBetweenNeEq | ExprBetweenEqNe | ExprBetweenEqEq | ExprMin | ExprMax | ExprPlus | ExprMinus | ExprAsterisk | ExprSlash | ExprMod | ExprRound | ExprCeil | ExprFloor;
export interface JsonExpressionExecutionContext {
    data: unknown;
}
export interface JsonExpressionCodegenContext {
    createPattern?: (pattern: string) => (value: string) => boolean;
}
