import type { CompactTestOp } from '../codec/compact/types';
import { OperationTest } from '../types';
import { Path } from '../../json-pointer';
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OPCODE } from '../constants';
import { AbstractOp } from './AbstractOp';
import { IMessagePackEncoder } from '../../json-pack/Encoder/types';
export declare class OpTest extends AbstractPredicateOp<'test'> {
    readonly value: unknown;
    readonly not: boolean;
    constructor(path: Path, value: unknown, not: boolean);
    op(): "test";
    code(): OPCODE;
    test(doc: unknown): boolean;
    toJson(parent?: AbstractOp): OperationTest;
    toCompact(parent: AbstractOp | undefined, verbose: boolean): CompactTestOp;
    encode(encoder: IMessagePackEncoder, parent?: AbstractOp): void;
}
