import type { IRpcApiCaller, RpcMethod } from '../rpc';
import type { JsonRpc2Codec } from './codec/types';
import type { JsonRpc2RequestMessage, JsonRpc2NotificationMessage } from './types';
export interface JsonRpc2ServerParams<Api extends Record<string, RpcMethod<Ctx, any, any>>, Ctx = unknown> {
    strict?: boolean;
    caller: IRpcApiCaller<Api, Ctx>;
    onNotification: (name: string, data: unknown, ctx: Ctx) => void;
    codec: JsonRpc2Codec;
}
export declare class JsonRpc2Server<Api extends Record<string, RpcMethod<Ctx, any, any>>, Ctx = unknown> {
    private readonly caller;
    private readonly strict;
    private readonly onNotification;
    private readonly codec;
    constructor(params: JsonRpc2ServerParams<Api, Ctx>);
    onMessage(ctx: Ctx, message: JsonRpc2RequestMessage | JsonRpc2NotificationMessage): Promise<void | unknown>;
    onMessages(ctx: Ctx, data: unknown): Promise<unknown>;
}
