import { json_string } from '../../../../../json-brand';
import type { JsonRpc2Error, JsonRpc2ErrorMessage, JsonRpc2Id, JsonRpc2IncomingMessage, JsonRpc2ResponseMessage } from '../../types';
import type { JsonRpc2Codec } from '../types';
export declare class JsonRpc2CodecJsonString implements JsonRpc2Codec {
    decode(data: json_string<JsonRpc2IncomingMessage | JsonRpc2IncomingMessage[]>): JsonRpc2IncomingMessage[];
    encodeError(error: JsonRpc2Error, id: JsonRpc2Id): json_string<JsonRpc2ErrorMessage>;
    encodeParseError(): json_string<JsonRpc2ErrorMessage>;
    encodeInvalidRequestError(id: JsonRpc2Id): unknown;
    encodeMethodNotFoundError(id: JsonRpc2Id): unknown;
    encodeInvalidParamsError(id: JsonRpc2Id): unknown;
    encodeInternalError(id: JsonRpc2Id): unknown;
    encodeResponse(id: JsonRpc2Id, result: unknown): json_string<JsonRpc2ResponseMessage>;
    encodeBatch(messages: json_string<JsonRpc2ResponseMessage>[]): json_string<JsonRpc2ResponseMessage[]>;
}
