"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryNotificationMessage = void 0;
const header_1 = require("../../codec/binary/header");
const nominal_1 = require("../nominal");
class BinaryNotificationMessage extends nominal_1.NotificationMessage {
    size() {
        const dataSize = this.data ? this.data.byteLength : 0;
        return (0, header_1.getHeaderSize)(dataSize) + 1 + this.method.length + dataSize;
    }
    writeCompact(encoder) {
        const data = this.data;
        const dataSize = data ? data.byteLength : 0;
        if (!dataSize) {
            encoder.encodeArrayHeader(1);
            encoder.encodeAsciiString(this.method);
            return;
        }
        encoder.encodeArrayHeader(2);
        encoder.encodeAsciiString(this.method);
        encoder.buf(data, dataSize);
    }
}
exports.BinaryNotificationMessage = BinaryNotificationMessage;
