"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryResponseCompleteMessage = void 0;
const header_1 = require("../../codec/binary/header");
const nominal_1 = require("../nominal");
class BinaryResponseCompleteMessage extends nominal_1.ResponseCompleteMessage {
    size() {
        const dataSize = this.data ? this.data.byteLength : 0;
        return (0, header_1.getHeaderSize)(dataSize) + 2 + dataSize;
    }
    writeCompact(encoder) {
        const data = this.data;
        const dataSize = data ? data.byteLength : 0;
        if (!dataSize) {
            encoder.encodeArrayHeader(2);
            encoder.u8(0);
            encoder.encodeUnsignedInteger(this.id);
            return;
        }
        encoder.encodeArrayHeader(3);
        encoder.u8(0);
        encoder.encodeUnsignedInteger(this.id);
        encoder.buf(data, dataSize);
    }
}
exports.BinaryResponseCompleteMessage = BinaryResponseCompleteMessage;
