"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonResponseCompleteMessage = void 0;
const nominal_1 = require("../nominal");
class JsonResponseCompleteMessage extends nominal_1.ResponseCompleteMessage {
    toValue() {
        return this.data !== undefined ? JSON.parse(this.data) : undefined;
    }
    toCompact() {
        const value = this.toValue();
        return value === undefined ? [0, this.id] : [0, this.id, value];
    }
    toCompactJson() {
        const data = this.data;
        if (data)
            return ('[0,' + this.id + ',' + data + ']');
        return ('[0,' + this.id + ']');
    }
}
exports.JsonResponseCompleteMessage = JsonResponseCompleteMessage;
