import type { RpcMethodStatic, RpcMethodStreaming } from './types';
import type { MsgPack } from '../../../json-pack';
import type { JsonTypeSystem } from '../../../json-type-system/JsonTypeSystem';
import { json_string } from '../../../json-brand';
import { Observable } from 'rxjs';
export declare class RpcMethodStaticWrap<Context = unknown, Request = unknown, Response = unknown> implements RpcMethodStatic<Context, Request, Response> {
    readonly isStreaming = false;
    readonly req: string;
    readonly res: string;
    readonly validate?: (request: Request) => void;
    readonly onPreCall?: (ctx: Context, request: Request) => Promise<void>;
    readonly pretty: boolean;
    readonly call: (ctx: Context, request: Request) => Promise<Response>;
    readonly callJson: (ctx: Context, request: Request) => Promise<json_string<Response>>;
    readonly callMsgPack: (ctx: Context, request: Request) => Promise<MsgPack<Response>>;
    readonly call$: (ctx: Context, request$: Observable<Request>) => Observable<Response>;
    readonly callJson$: (ctx: Context, request$: Observable<Request>) => Observable<json_string<Response>>;
    readonly callMsgPack$: (ctx: Context, request$: Observable<Request>) => Observable<MsgPack<Response>>;
    constructor(method: RpcMethodStatic<Context, Request, Response>, types?: JsonTypeSystem<{}>);
}
export declare class RpcMethodStreamingWrap<Context = unknown, Request = unknown, Response = unknown> implements RpcMethodStreaming<Context, Request, Response> {
    readonly isStreaming = true;
    readonly req: string;
    readonly res: string;
    readonly validate?: (request: Request) => void;
    readonly onPreCall?: (ctx: Context, request: Request) => Promise<void>;
    readonly pretty: boolean;
    readonly preCallBufferSize?: number;
    readonly timeout?: number;
    readonly call: (ctx: Context, request: Request) => Promise<Response>;
    readonly callJson: (ctx: Context, request: Request) => Promise<json_string<Response>>;
    readonly callMsgPack: (ctx: Context, request: Request) => Promise<MsgPack<Response>>;
    readonly call$: (ctx: Context, request$: Observable<Request>) => Observable<Response>;
    readonly callJson$: (ctx: Context, request$: Observable<Request>) => Observable<json_string<Response>>;
    readonly callMsgPack$: (ctx: Context, request$: Observable<Request>) => Observable<MsgPack<Response>>;
    constructor(method: RpcMethodStreaming<Context, Request, Response>, types?: JsonTypeSystem<{}>);
}
export declare const wrapMethod: <Context = unknown, Request_1 = unknown, Response_1 = unknown>(method: RpcMethodStatic<Context, Request_1, Response_1> | RpcMethodStreaming<Context, Request_1, Response_1>, types?: JsonTypeSystem<any> | undefined) => RpcMethodStaticWrap<Context, Request_1, Response_1> | RpcMethodStreamingWrap<Context, Request_1, Response_1>;
