import { ITimestamp, IClock } from './clock';
import { Patch } from './Patch';
export declare class PatchBuilder {
    readonly clock: IClock;
    readonly patch: Patch;
    constructor(clock: IClock);
    obj(): ITimestamp;
    arr(): ITimestamp;
    str(): ITimestamp;
    bin(): ITimestamp;
    num(): ITimestamp;
    const(value: unknown): ITimestamp;
    val(value: unknown): ITimestamp;
    root(value: ITimestamp): ITimestamp;
    setKeys(obj: ITimestamp, tuples: [key: string, value: ITimestamp][]): ITimestamp;
    setNum(obj: ITimestamp, value: number): ITimestamp;
    setVal(obj: ITimestamp, value: unknown): ITimestamp;
    insStr(obj: ITimestamp, after: ITimestamp, substring: string): ITimestamp;
    insBin(obj: ITimestamp, after: ITimestamp, data: Uint8Array): ITimestamp;
    insArr(arr: ITimestamp, after: ITimestamp, elements: ITimestamp[]): ITimestamp;
    del(obj: ITimestamp, start: ITimestamp, span: number): ITimestamp;
    noop(span: number): ITimestamp;
    jsonObj(json: object): ITimestamp;
    jsonArr(json: unknown[]): ITimestamp;
    jsonStr(json: string): ITimestamp;
    jsonBin(json: Uint8Array): ITimestamp;
    jsonVal(json: unknown): ITimestamp;
    json(json: unknown): ITimestamp;
    private pad;
}
