import { ServerTimestamp } from './server';
import type { IClock, IVectorClock, ITimespan, ITimestamp } from './types';
export declare class LogicalTimestamp extends ServerTimestamp implements ITimestamp {
    sessionId: number;
    time: number;
    constructor(sessionId: number, time: number);
    getSessionId(): number;
    stamp(sessionId: number, time: number): ServerTimestamp;
    tick(cycles: number): ITimestamp;
    interval(cycles: number, span: number): ITimespan;
    clock(): IClock;
}
export declare class LogicalTimespan extends LogicalTimestamp implements ITimespan {
    span: number;
    constructor(sessionId: number, time: number, span: number);
}
export declare class LogicalClock extends LogicalTimestamp implements IClock {
    tick(cycles: number): ITimestamp;
}
export declare class LogicalVectorClock extends LogicalClock implements IVectorClock {
    readonly clocks: Map<number, ITimestamp>;
    observe(ts: ITimestamp, span: number): void;
    clone(): LogicalVectorClock;
    fork(sessionId: number): LogicalVectorClock;
}
