import { ArrayChunk } from '../../types/rga-array/ArrayChunk';
import { ArrayType } from '../../types/rga-array/ArrayType';
import { BinaryChunk } from '../../types/rga-binary/BinaryChunk';
import { BinaryType } from '../../types/rga-binary/BinaryType';
import { ClockEncoder } from '../../../json-crdt-patch/codec/clock/ClockEncoder';
import { ConstantType } from '../../types/const/ConstantType';
import { CrdtEncoder } from '../../../json-crdt-patch/util/binary/CrdtEncoder';
import { DocRootType } from '../../types/lww-doc-root/DocRootType';
import { ITimestamp } from '../../../json-crdt-patch/clock';
import { JsonNode } from '../../types';
import { ObjectChunk } from '../../types/lww-object/ObjectChunk';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { StringChunk } from '../../types/rga-string/StringChunk';
import { StringType } from '../../types/rga-string/StringType';
import { ValueType } from '../../types/lww-value/ValueType';
import type { Model } from '../../model';
export declare class Encoder extends CrdtEncoder {
    protected clockEncoder?: ClockEncoder;
    protected time?: number;
    protected literals?: Map<unknown, number>;
    encode(model: Model): Uint8Array;
    protected encodeLiteralsTable(model: Model): void;
    protected encodeClockTable(data: Uint8Array): void;
    protected ts(ts: ITimestamp): void;
    protected encodeRoot(root: DocRootType): void;
    protected encodeNode(node: JsonNode): void;
    protected encodeObj(obj: ObjectType): void;
    protected encodeObjChunk(key: string, chunk: ObjectChunk): void;
    protected encodeArr(obj: ArrayType): void;
    protected encodeArrChunk(chunk: ArrayChunk): void;
    protected encodeStr(obj: StringType): void;
    protected encodeStrChunk(chunk: StringChunk): void;
    protected encodeBin(obj: BinaryType): void;
    protected encodeBinChunk(chunk: BinaryChunk): void;
    protected encodeConst(obj: ConstantType): void;
    protected encodeVal(obj: ValueType): void;
    private encodeUtf8;
}
