import { NodeApi } from './NodeApi';
export class ArrayApi extends NodeApi {
    ins(index, values) {
        const { api, node } = this;
        const { builder } = api;
        const after = !index ? node.id : node.findId(index - 1);
        const valueIds = [];
        for (let i = 0; i < values.length; i++)
            valueIds.push(builder.json(values[i]));
        builder.insArr(node.id, after, valueIds);
        return this;
    }
    del(index, length) {
        const { api, node } = this;
        const { builder } = api;
        const spans = node.findIdSpans(index, length);
        for (const ts of spans)
            builder.del(node.id, ts, ts.span);
        return this;
    }
}
