import { ArrayApi } from './ArrayApi';
import { BinaryApi } from './BinaryApi';
import { ObjectApi } from './ObjectApi';
import { StringApi } from './StringApi';
import { ValueApi } from './ValueApi';
import type { JsonNode } from '../../types';
import type { ModelApi } from './ModelApi';
import type { Path } from '../../../json-pointer';
export declare class Finder {
    protected readonly node: JsonNode;
    protected readonly api: ModelApi;
    constructor(node: JsonNode, api: ModelApi);
    find(steps: Path): JsonNode;
    val(path: Path): ValueApi;
    str(path: Path): StringApi;
    bin(path: Path): BinaryApi;
    arr(path: Path): ArrayApi;
    obj(path: Path): ObjectApi;
}
