import { Batch } from '../../../json-crdt-patch/Batch';
import { Finder } from './Finder';
import { JsonNode } from '../../types';
import { Patch } from '../../../json-crdt-patch/Patch';
import { PatchBuilder } from '../../../json-crdt-patch/PatchBuilder';
import { Path } from '../../../json-pointer';
import type { Model } from '../Model';
export declare class ModelApi {
    readonly model: Model;
    batch: Batch;
    builder: PatchBuilder;
    protected getApi(): this;
    constructor(model: Model);
    getNode(): JsonNode | import("../../types/const/ConstantBuiltin").ConstantBuiltin;
    find(): Finder;
    find(path: Path): JsonNode;
    val(path: Path): import("./ValueApi").ValueApi;
    str(path: Path): import("./StringApi").StringApi;
    bin(path: Path): import("./BinaryApi").BinaryApi;
    arr(path: Path): import("./ArrayApi").ArrayApi;
    obj(path: Path): import("./ObjectApi").ObjectApi;
    commit(): Patch;
    flush(): Batch;
    patch(cb: (api: this) => void): void;
    root(json: unknown): this;
    toView(): unknown;
}
