import { UNDEFINED_ID } from '../../../json-crdt-patch/constants';
export class DocRootType {
    doc;
    id;
    node;
    constructor(doc, id, node) {
        this.doc = doc;
        this.id = id;
        this.node = node;
    }
    insert(op) {
        if (!this.node) {
            this.set(op.id, op.value);
            return null;
        }
        else if (op.id.compare(this.id) > 0) {
            const node = this.node;
            this.set(op.id, op.value);
            return node.id;
        }
        return null;
    }
    set(id, value) {
        const node = this.doc.node(value);
        if (!node)
            return;
        this.id = id;
        this.node = node;
    }
    toValue() {
        return this.node ? this.node.id : UNDEFINED_ID;
    }
    toJson() {
        return !this.node ? undefined : this.node.toJson();
    }
    toString(tab = '') {
        return this.node ? this.node.toString(tab) : 'undefined';
    }
    clone(doc) {
        return new DocRootType(doc, this.id, this.node ? this.node.clone(doc) : null);
    }
    *children() {
        if (this.node)
            yield this.node.id;
    }
}
