import type { CompactAndOp } from '../codec/compact/types';
import { AbstractSecondOrderPredicateOp } from './AbstractSecondOrderPredicateOp';
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationAnd } from '../types';
import { OPCODE } from '../constants';
import { Path } from '../../json-pointer';
import { AbstractOp } from './AbstractOp';
import { IMessagePackEncoder } from '../../json-pack/Encoder/types';
export declare class OpAnd extends AbstractSecondOrderPredicateOp<'and'> {
    readonly ops: AbstractPredicateOp[];
    constructor(path: Path, ops: AbstractPredicateOp[]);
    op(): "and";
    code(): OPCODE;
    test(doc: unknown): boolean;
    toJson(parent?: AbstractOp): OperationAnd;
    toCompact(parent: undefined | AbstractOp, verbose: boolean): CompactAndOp;
    encode(encoder: IMessagePackEncoder, parent?: AbstractOp): void;
}
