import type { CompactMoreOp } from '../codec/compact/types';
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationMore } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from '../constants';
import { AbstractOp } from './AbstractOp';
import { IMessagePackEncoder } from '../../json-pack/Encoder/types';
export declare class OpMore extends AbstractPredicateOp<'more'> {
    readonly value: number;
    constructor(path: Path, value: number);
    op(): "more";
    code(): OPCODE;
    test(doc: unknown): boolean;
    toJson(parent?: AbstractOp): OperationMore;
    toCompact(parent: undefined | AbstractOp, verbose: boolean): CompactMoreOp;
    encode(encoder: IMessagePackEncoder, parent?: AbstractOp): void;
}
