import { json_string } from '../json-brand';
import { TArray, TBoolean, TNumber, TObject, TString, TType, TRef } from '../json-type/types';
import { Codegen } from '../util/codegen';
import { JsExpression } from '../util/codegen/util/JsExpression';
export declare type JsonEncoderFn = <T>(value: T) => json_string<T>;
export interface JsonSerializerCodegenOptions {
    type: TType;
    ref?: (id: string) => JsonEncoderFn | TType | undefined;
}
export declare class JsonSerializerCodegen {
    protected options: Required<JsonSerializerCodegenOptions>;
    protected codegen: Codegen<JsonEncoderFn>;
    constructor(opts: JsonSerializerCodegenOptions);
    protected base64Linked: boolean;
    protected linkBase64(): void;
    protected js(js: string): void;
    protected writeText(str: string): void;
    onString(str: TString, value: JsExpression): void;
    onNumber(num: TNumber, value: JsExpression): void;
    onBoolean(bool: TBoolean, value: JsExpression): void;
    onNull(): void;
    onArray(arr: TArray, value: JsExpression): void;
    onObject(obj: TObject, value: JsExpression): void;
    onBinary(value: JsExpression): void;
    onRef(ref: TRef, value: JsExpression): void;
    onAny(value: JsExpression): void;
    onType(type: TType, value: JsExpression): void;
    run(): this;
    generate(): import("../util/codegen").JavaScriptLinked<JsonEncoderFn, unknown[]>;
    compile(): JsonEncoderFn;
}
