import type { json_string } from '../json-brand';
import type { JsonTypeValidatorError } from './codegen';
export declare type JsonTypeValidator = (value: unknown) => unknown;
export declare type BooleanValidator = (value: unknown) => boolean;
export declare type StringValidatorSuccess = '';
export declare type StringValidatorError = [code: string, message: string];
export declare type StringValidator = (value: unknown) => json_string<StringValidatorSuccess | StringValidatorError>;
export declare type ObjectValidatorSuccess = null;
export interface ObjectValidatorError {
    code: string;
    errno: JsonTypeValidatorError;
    message: string;
    path: Array<string | number>;
}
export declare type ObjectValidator = (value: unknown) => ObjectValidatorSuccess | ObjectValidatorError;
export interface CustomValidator {
    name: string;
    types: CustomValidatorType[];
    fn: (value: any) => unknown;
}
export declare type CustomValidatorType = 'string' | 'number' | 'array' | 'object' | 'bin' | 'any';
