import { decodeFullMessages } from '../binary/decode';
import { decoder } from '../../../../json-pack/util';
import { isUint8Array } from '../../../../util/isUint8Array';
export class Decoder {
    msgpack = decoder;
    convertMessage(message) {
        const data = message.data;
        if (isUint8Array(data)) {
            if (!data.byteLength)
                message.data = undefined;
            else
                message.data = this.msgpack.decode(data);
        }
        return message;
    }
    decode(arr) {
        const binaryMessages = decodeFullMessages(arr, 0, arr.byteLength);
        const messages = [];
        const length = binaryMessages.length;
        for (let i = 0; i < length; i++)
            messages.push(this.convertMessage(binaryMessages[i]));
        return messages;
    }
}
