import { getHeaderSize } from '../../codec/binary/header';
import { NotificationMessage } from '../nominal';
export class BinaryNotificationMessage extends NotificationMessage {
    size() {
        const dataSize = this.data ? this.data.byteLength : 0;
        return getHeaderSize(dataSize) + 1 + this.method.length + dataSize;
    }
    writeCompact(encoder) {
        const data = this.data;
        const dataSize = data ? data.byteLength : 0;
        if (!dataSize) {
            encoder.encodeArrayHeader(1);
            encoder.encodeAsciiString(this.method);
            return;
        }
        encoder.encodeArrayHeader(2);
        encoder.encodeAsciiString(this.method);
        encoder.buf(data, dataSize);
    }
}
