import { getHeaderSize } from '../../codec/binary/header';
import { ResponseCompleteMessage } from '../nominal';
export class BinaryResponseCompleteMessage extends ResponseCompleteMessage {
    size() {
        const dataSize = this.data ? this.data.byteLength : 0;
        return getHeaderSize(dataSize) + 2 + dataSize;
    }
    writeCompact(encoder) {
        const data = this.data;
        const dataSize = data ? data.byteLength : 0;
        if (!dataSize) {
            encoder.encodeArrayHeader(2);
            encoder.u8(0);
            encoder.encodeUnsignedInteger(this.id);
            return;
        }
        encoder.encodeArrayHeader(3);
        encoder.u8(0);
        encoder.encodeUnsignedInteger(this.id);
        encoder.buf(data, dataSize);
    }
}
