import { NotificationMessage, RequestCompleteMessage, RequestDataMessage, RequestErrorMessage, RequestUnsubscribeMessage, ResponseCompleteMessage, ResponseDataMessage, ResponseErrorMessage, ResponseUnsubscribeMessage, } from '../messages/nominal';
export class RpcDuplex {
    client;
    server;
    constructor(params) {
        this.client = params.client;
        this.server = params.server;
    }
    onMessages(messages, ctx) {
        const length = messages.length;
        for (let i = 0; i < length; i++)
            this.onMessage(messages[i], ctx);
    }
    onMessage(message, ctx) {
        if (message instanceof RequestDataMessage)
            this.server.onRequestDataMessage(message, ctx);
        else if (message instanceof RequestCompleteMessage)
            this.server.onRequestCompleteMessage(message, ctx);
        else if (message instanceof RequestErrorMessage)
            this.server.onRequestErrorMessage(message, ctx);
        else if (message instanceof ResponseUnsubscribeMessage)
            this.server.onUnsubscribeMessage(message);
        else if (message instanceof NotificationMessage)
            this.server.onNotificationMessage(message, ctx);
        else if (message instanceof ResponseCompleteMessage)
            return this.client.onResponseComplete(message);
        else if (message instanceof ResponseDataMessage)
            return this.client.onResponseData(message);
        else if (message instanceof ResponseErrorMessage)
            return this.client.onResponseError(message);
        else if (message instanceof RequestUnsubscribeMessage)
            return this.client.onRequestUnsubscribe(message);
    }
    call$(method, data) {
        return this.client.call$(method, data);
    }
    call(method, data) {
        return this.client.call(method, data);
    }
    notify(method, data) {
        this.client.notify(method, data);
    }
    stop() {
        this.client.stop();
        this.server.stop();
    }
    disconnect() {
        this.client.disconnect();
        this.server.disconnect();
    }
}
