import { Observable, ReplaySubject } from 'rxjs';
import { Codec } from '../codec/types';
import { RpcClientParams } from '../rpc';
import { RpcDuplex } from '../rpc/RpcDuplex';
import { RpcServerParams } from '../rpc/RpcServer';
import { PersistentChannel, PersistentChannelParams } from '../channel';
export interface RpcPersistentClientParams<Ctx = unknown, T = unknown> {
    channel: PersistentChannelParams;
    codec: Codec<string | Uint8Array>;
    client?: Omit<RpcClientParams<T>, 'send'>;
    server?: Omit<RpcServerParams<Ctx>, 'send'>;
    ping?: number;
}
export declare class RpcPersistentClient<Ctx = unknown, T = unknown> {
    channel: PersistentChannel;
    rpc?: RpcDuplex<Ctx, T>;
    readonly rpc$: ReplaySubject<RpcDuplex<Ctx, T>>;
    constructor(params: RpcPersistentClientParams<Ctx, T>);
    call$(method: string, data: T | Observable<T>): Observable<T>;
    call(method: string, data: T): Promise<T>;
    notify(method: string, data: T): void;
    start(): void;
    stop(): void;
}
