import { RpcServer } from './RpcServer';
import { JSON } from '../../../json-brand';
import { JsonNotificationMessage } from '../messages/json/JsonNotificationMessage';
import { JsonRequestUnsubscribeMessage } from '../messages/json/JsonRequestUnsubscribeMessage';
import { JsonResponseCompleteMessage } from '../messages/json/JsonResponseCompleteMessage';
import { JsonResponseDataMessage } from '../messages/json/JsonResponseDataMessage';
import { JsonResponseErrorMessage } from '../messages/json/JsonResponseErrorMessage';
const stringify = JSON.stringify;
export class RpcServerJson extends RpcServer {
    notifMessage(method, data) {
        return new JsonNotificationMessage(method, stringify(data));
    }
    resCompleteMessage(id, data) {
        return new JsonResponseCompleteMessage(id, data);
    }
    resDataMessage(id, data) {
        return new JsonResponseDataMessage(id, data);
    }
    resErrorMessage(id, data) {
        return new JsonResponseErrorMessage(id, stringify(data));
    }
    reqUnsubscribeMessage(id) {
        return new JsonRequestUnsubscribeMessage(id);
    }
    createStaticCall(name, request, ctx) {
        return this.caller.callJson(name, request, ctx);
    }
    createCall(name, ctx) {
        const streamCallback = (method, ctx, req$) => method.callJson$(ctx, req$);
        return this.caller.createCall(name, ctx, (name, req, ctx) => this.caller.callJson(name, req, ctx), streamCallback);
    }
}
