import { RpcServer } from './RpcServer';
import type { Call } from './RpcApiCaller';
import { BinaryNotificationMessage, BinaryResponseCompleteMessage, BinaryResponseDataMessage, BinaryResponseErrorMessage, BinaryRequestUnsubscribeMessage } from '../messages/binary';
export declare class RpcServerMsgPack<Ctx = unknown> extends RpcServer<Ctx> {
    protected notifMessage(method: string, data: unknown): BinaryNotificationMessage;
    protected resCompleteMessage(id: number, data: unknown): BinaryResponseCompleteMessage;
    protected resDataMessage(id: number, data: unknown): BinaryResponseDataMessage;
    protected resErrorMessage(id: number, data: unknown): BinaryResponseErrorMessage;
    protected reqUnsubscribeMessage(id: number): BinaryRequestUnsubscribeMessage;
    protected createStaticCall(name: string, request: unknown, ctx: Ctx): Promise<unknown>;
    protected createCall(name: string, ctx: Ctx): Call<unknown, unknown>;
}
