import { RpcServer } from './RpcServer';
import { BinaryNotificationMessage, BinaryResponseCompleteMessage, BinaryResponseDataMessage, BinaryResponseErrorMessage, BinaryRequestUnsubscribeMessage, } from '../messages/binary';
import { encodeFull } from '../../../json-pack/util';
export class RpcServerMsgPack extends RpcServer {
    notifMessage(method, data) {
        return new BinaryNotificationMessage(method, encodeFull(data));
    }
    resCompleteMessage(id, data) {
        return new BinaryResponseCompleteMessage(id, data);
    }
    resDataMessage(id, data) {
        return new BinaryResponseDataMessage(id, data);
    }
    resErrorMessage(id, data) {
        return new BinaryResponseErrorMessage(id, encodeFull(data));
    }
    reqUnsubscribeMessage(id) {
        return new BinaryRequestUnsubscribeMessage(id);
    }
    createStaticCall(name, request, ctx) {
        return this.caller.callMsgPack(name, request, ctx);
    }
    createCall(name, ctx) {
        const streamCallback = (method, ctx, req$) => method.callMsgPack$(ctx, req$);
        return this.caller.createCall(name, ctx, (name, req, ctx) => this.caller.callMsgPack(name, req, ctx), streamCallback);
    }
}
