"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var json_patch_1 = require("../json-patch");
var applyPatch_1 = require("../json-patch/applyPatch");
var util_1 = require("../json-patch/util");
try {
    var buf = (0, fs_1.readFileSync)(0);
    var doc = JSON.parse(buf.toString());
    var patch = JSON.parse(process.argv[2]);
    patch.forEach(json_patch_1.validateOperation);
    var res = (0, applyPatch_1.applyPatch)(doc, patch, { mutate: true, createMatcher: util_1.createMatcherDefault });
    process.stdout.write(JSON.stringify(res.doc, null, 4) + '\n');
}
catch (error) {
    var output = error instanceof Error ? error.message : String(error);
    process.stderr.write(output + '\n');
    process.exit(1);
}
