"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.clone = void 0;
var isArray = Array.isArray;
var objectKeys = Object.keys;
var clone = function (obj) {
    if (!obj)
        return obj;
    if (isArray(obj)) {
        var arr = [];
        var length_1 = obj.length;
        for (var i = 0; i < length_1; i++)
            arr.push((0, exports.clone)(obj[i]));
        return arr;
    }
    else if (typeof obj === 'object') {
        var keys = objectKeys(obj);
        var length_2 = keys.length;
        var newObject = {};
        for (var i = 0; i < length_2; i++) {
            var key = keys[i];
            newObject[key] = (0, exports.clone)(obj[key]);
        }
        return newObject;
    }
    return obj;
};
exports.clone = clone;
