"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cloneBinary = void 0;
var isUint8Array_1 = require("../util/isUint8Array");
var isArray = Array.isArray;
var objectKeys = Object.keys;
var cloneBinary = function (obj) {
    if (!obj)
        return obj;
    if (isArray(obj)) {
        var arr = [];
        var length_1 = obj.length;
        for (var i = 0; i < length_1; i++)
            arr.push((0, exports.cloneBinary)(obj[i]));
        return arr;
    }
    else if (typeof obj === 'object') {
        if ((0, isUint8Array_1.isUint8Array)(obj))
            return new Uint8Array(obj);
        var keys = objectKeys(obj);
        var length_2 = keys.length;
        var newObject = {};
        for (var i = 0; i < length_2; i++) {
            var key = keys[i];
            newObject[key] = (0, exports.cloneBinary)(obj[key]);
        }
        return newObject;
    }
    return obj;
};
exports.cloneBinary = cloneBinary;
