import { DeleteOperation } from './operations/DeleteOperation';
import { InsertArrayElementsOperation } from './operations/InsertArrayElementsOperation';
import { InsertBinaryDataOperation } from './operations/InsertBinaryDataOperation';
import { InsertStringSubstringOperation } from './operations/InsertStringSubstringOperation';
import { MakeArrayOperation } from './operations/MakeArrayOperation';
import { MakeBinaryOperation } from './operations/MakeBinaryOperation';
import { MakeConstantOperation } from './operations/MakeConstantOperation';
import { MakeNumberOperation } from './operations/MakeNumberOperation';
import { MakeObjectOperation } from './operations/MakeObjectOperation';
import { MakeStringOperation } from './operations/MakeStringOperation';
import { MakeValueOperation } from './operations/MakeValueOperation';
import { NoopOperation } from './operations/NoopOperation';
import { SetNumberOperation } from './operations/SetNumberOperation';
import { SetObjectKeysOperation } from './operations/SetObjectKeysOperation';
import { SetRootOperation } from './operations/SetRootOperation';
import { SetValueOperation } from './operations/SetValueOperation';
import { ITimestamp } from './clock';
export declare type JsonCrdtPatchOperation = DeleteOperation | InsertArrayElementsOperation | InsertStringSubstringOperation | InsertBinaryDataOperation | MakeArrayOperation | MakeConstantOperation | MakeNumberOperation | MakeObjectOperation | MakeStringOperation | MakeBinaryOperation | MakeValueOperation | NoopOperation | SetNumberOperation | SetValueOperation | SetObjectKeysOperation | SetRootOperation;
export declare class Patch {
    readonly ops: JsonCrdtPatchOperation[];
    constructor();
    getId(): ITimestamp | undefined;
    span(): number;
    nextTime(): number;
    rewriteTime(ts: (id: ITimestamp) => ITimestamp): Patch;
    rebase(serverTime: number, transformHorizon: number): Patch;
    clone(): Patch;
}
