export interface ITimestamp {
    time: number;
    getSessionId(): number;
    isEqual(ts: ITimestamp): boolean;
    compare(ts: ITimestamp): -1 | 0 | 1;
    inSpan(span: number, ts: ITimestamp, tsSpan: number): boolean;
    overlap(span: number, ts: ITimestamp, tsSpan: number): number;
    stamp(sessionId: number, time: number): ITimestamp;
    tick(cycles: number): ITimestamp;
    interval(cycles: number, span: number): ITimespan;
    toString(): string;
    toDisplayString(): string;
    clock(): IClock;
    compact(): string;
}
export interface ITimespan extends ITimestamp {
    span: number;
}
export interface IClock extends ITimestamp {
    tick(cycles: number): ITimestamp;
}
export interface IVectorClock extends IClock {
    readonly clocks: Map<number, ITimestamp>;
    observe(ts: ITimestamp, span: number): void;
    clone(): IVectorClock;
    fork(sessionId: number): IVectorClock;
}
