"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrdtEncoder = void 0;
var tslib_1 = require("tslib");
var EncoderFull_1 = require("../../../json-pack/EncoderFull");
var CrdtEncoder = (function (_super) {
    (0, tslib_1.__extends)(CrdtEncoder, _super);
    function CrdtEncoder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CrdtEncoder.prototype.id = function (x, y) {
        if (x <= 7 && y <= 15) {
            this.u8((x << 4) | y);
        }
        else {
            this.b1vuint28(true, x);
            this.vuint39(y);
        }
    };
    CrdtEncoder.prototype.vuint57 = function (num) {
        if (num <= 127) {
            this.u8(num);
        }
        else if (num <= 16383) {
            this.u8(128 | (num & 127));
            this.u8(num >>> 7);
        }
        else if (num <= 2097151) {
            this.u8(128 | (num & 127));
            this.u8(128 | ((num >>> 7) & 127));
            this.u8(num >>> 14);
        }
        else if (num <= 268435455) {
            this.u8(128 | (num & 127));
            this.u8(128 | ((num >>> 7) & 127));
            this.u8(128 | ((num >>> 14) & 127));
            this.u8(num >>> 21);
        }
        else {
            var lo32 = num | 0;
            if (lo32 < 0)
                lo32 += 4294967296;
            var hi32 = (num - lo32) / 4294967296;
            if (num <= 34359738367) {
                this.u8(128 | (num & 127));
                this.u8(128 | ((num >>> 7) & 127));
                this.u8(128 | ((num >>> 14) & 127));
                this.u8(128 | ((num >>> 21) & 127));
                this.u8((hi32 << 4) | (num >>> 28));
            }
            else if (num <= 4398046511103) {
                this.u8(128 | (num & 127));
                this.u8(128 | ((num >>> 7) & 127));
                this.u8(128 | ((num >>> 14) & 127));
                this.u8(128 | ((num >>> 21) & 127));
                this.u8(128 | ((hi32 & 7) << 4) | (num >>> 28));
                this.u8(hi32 >>> 3);
            }
            else if (num <= 562949953421311) {
                this.u8(128 | (num & 127));
                this.u8(128 | ((num >>> 7) & 127));
                this.u8(128 | ((num >>> 14) & 127));
                this.u8(128 | ((num >>> 21) & 127));
                this.u8(128 | ((hi32 & 7) << 4) | (num >>> 28));
                this.u8(128 | ((hi32 & 1016) >>> 3));
                this.u8(hi32 >>> 10);
            }
            else {
                this.u8(128 | (num & 127));
                this.u8(128 | ((num >>> 7) & 127));
                this.u8(128 | ((num >>> 14) & 127));
                this.u8(128 | ((num >>> 21) & 127));
                this.u8(128 | ((hi32 & 7) << 4) | (num >>> 28));
                this.u8(128 | ((hi32 & 1016) >>> 3));
                this.u8(128 | ((hi32 & 130048) >>> 10));
                this.u8(hi32 >>> 17);
            }
        }
    };
    CrdtEncoder.prototype.vuint39 = function (num) {
        if (num <= 127) {
            this.u8(num);
        }
        else if (num <= 16383) {
            this.u8(128 | (num & 127));
            this.u8(num >>> 7);
        }
        else if (num <= 2097151) {
            this.u8(128 | (num & 127));
            this.u8(128 | ((num >>> 7) & 127));
            this.u8(num >>> 14);
        }
        else if (num <= 268435455) {
            this.u8(128 | (num & 127));
            this.u8(128 | ((num >>> 7) & 127));
            this.u8(128 | ((num >>> 14) & 127));
            this.u8(num >>> 21);
        }
        else {
            var lo32 = num | 0;
            if (lo32 < 0)
                lo32 += 4294967296;
            var hi32 = (num - lo32) / 4294967296;
            if (num <= 34359738367) {
                this.u8(128 | (num & 127));
                this.u8(128 | ((num >>> 7) & 127));
                this.u8(128 | ((num >>> 14) & 127));
                this.u8(128 | ((num >>> 21) & 127));
                this.u8((hi32 << 4) | (num >>> 28));
            }
            else if (num <= 4398046511103) {
                this.u8(128 | (num & 127));
                this.u8(128 | ((num >>> 7) & 127));
                this.u8(128 | ((num >>> 14) & 127));
                this.u8(128 | ((num >>> 21) & 127));
                this.u8(128 | ((hi32 & 7) << 4) | (num >>> 28));
                this.u8((hi32 >>> 3) & 15);
            }
        }
    };
    CrdtEncoder.prototype.b1vuint56 = function (flag, num) {
        if (num <= 63) {
            this.u8((flag ? 128 : 0) | num);
        }
        else {
            var firstByteMask = flag ? 192 : 64;
            if (num <= 8191) {
                this.u8(firstByteMask | (num & 63));
                this.u8(num >>> 6);
            }
            else if (num <= 1048575) {
                this.u8(firstByteMask | (num & 63));
                this.u8(128 | ((num >>> 6) & 127));
                this.u8(num >>> 13);
            }
            else if (num <= 134217727) {
                this.u8(firstByteMask | (num & 63));
                this.u8(128 | ((num >>> 6) & 127));
                this.u8(128 | ((num >>> 13) & 127));
                this.u8(num >>> 20);
            }
            else {
                var lo32 = num | 0;
                if (lo32 < 0)
                    lo32 += 4294967296;
                var hi32 = (num - lo32) / 4294967296;
                if (num <= 17179869183) {
                    this.u8(firstByteMask | (num & 63));
                    this.u8(128 | ((num >>> 6) & 127));
                    this.u8(128 | ((num >>> 13) & 127));
                    this.u8(128 | ((num >>> 20) & 127));
                    this.u8((hi32 << 5) | (num >>> 27));
                }
                else if (num <= 2199023255551) {
                    this.u8(firstByteMask | (num & 63));
                    this.u8(128 | ((num >>> 6) & 127));
                    this.u8(128 | ((num >>> 13) & 127));
                    this.u8(128 | ((num >>> 20) & 127));
                    this.u8(128 | ((hi32 & 3) << 5) | (num >>> 27));
                    this.u8(hi32 >>> 2);
                }
                else if (num <= 281474976710655) {
                    this.u8(firstByteMask | (num & 63));
                    this.u8(128 | ((num >>> 6) & 127));
                    this.u8(128 | ((num >>> 13) & 127));
                    this.u8(128 | ((num >>> 20) & 127));
                    this.u8(128 | ((hi32 & 3) << 5) | (num >>> 27));
                    this.u8(128 | ((hi32 & 508) >>> 2));
                    this.u8(hi32 >>> 9);
                }
                else {
                    this.u8(firstByteMask | (num & 63));
                    this.u8(128 | ((num >>> 6) & 127));
                    this.u8(128 | ((num >>> 13) & 127));
                    this.u8(128 | ((num >>> 20) & 127));
                    this.u8(128 | ((hi32 & 3) << 5) | (num >>> 27));
                    this.u8(128 | ((hi32 & 508) >>> 2));
                    this.u8(128 | ((hi32 & 65024) >>> 9));
                    this.u8(hi32 >>> 16);
                }
            }
        }
    };
    CrdtEncoder.prototype.b1vuint28 = function (flag, num) {
        if (num <= 63) {
            this.u8((flag ? 128 : 0) | num);
        }
        else {
            var firstByteMask = flag ? 192 : 64;
            if (num <= 8191) {
                this.u8(firstByteMask | (num & 63));
                this.u8(num >>> 6);
            }
            else if (num <= 1048575) {
                this.u8(firstByteMask | (num & 63));
                this.u8(128 | ((num >>> 6) & 127));
                this.u8(num >>> 13);
            }
            else {
                this.u8(firstByteMask | (num & 63));
                this.u8(128 | ((num >>> 6) & 127));
                this.u8(128 | ((num >>> 13) & 127));
                this.u8(num >>> 20);
            }
        }
    };
    CrdtEncoder.prototype.uint53vuint39 = function (x, z) {
        var x1 = x | 0;
        if (x1 < 0)
            x1 += 4294967296;
        var x2 = (x - x1) / 4294967296;
        this.u32(x1);
        this.u16(x2 & 0xffff);
        var fiveXBits = (x2 >>> 16) << 3;
        var twoZBits = (z >>> 8) & 3;
        var zFitsIn10Bits = z <= 1023;
        this.u8(fiveXBits | (zFitsIn10Bits ? 0 : 4) | twoZBits);
        this.u8(z & 0xff);
        if (zFitsIn10Bits)
            return;
        if (z <= 131071) {
            this.u8(z >>> 10);
        }
        else if (z <= 16777215) {
            this.u8(128 | ((z >>> 10) & 127));
            this.u8(z >>> 17);
        }
        else if (z <= 2147483647) {
            this.u8(128 | ((z >>> 10) & 127));
            this.u8(128 | ((z >>> 17) & 127));
            this.u8(z >>> 24);
        }
        else {
            var z1 = z | 0;
            if (z1 < 0)
                z1 += 4294967296;
            var z2 = (z - z1) / 4294967296;
            this.u8(128 | ((z1 >>> 10) & 127));
            this.u8(128 | ((z1 >>> 17) & 127));
            this.u8(128 | ((z1 >>> 24) & 127));
            this.u8((z1 >>> 31) | (z2 << 1));
        }
    };
    return CrdtEncoder;
}(EncoderFull_1.EncoderFull));
exports.CrdtEncoder = CrdtEncoder;
