import { ArrayType } from '../../types/rga-array/ArrayType';
import { BinaryType } from '../../types/rga-binary/BinaryType';
import { ClockDecoder } from '../../../json-crdt-patch/codec/clock/ClockDecoder';
import { CrdtDecoder } from '../../../json-crdt-patch/util/binary/CrdtDecoder';
import { ITimestamp } from '../../../json-crdt-patch/clock';
import { Model } from '../../model';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { StringType } from '../../types/rga-string/StringType';
import type { JsonNode } from '../../types';
export declare class Decoder extends CrdtDecoder {
    protected doc: Model;
    protected clockDecoder?: ClockDecoder;
    protected time: number;
    protected literals?: unknown[];
    decode(data: Uint8Array): Model;
    protected decodeClockTable(length: number): void;
    protected ts(): ITimestamp;
    protected decodeRoot(): void;
    decodeNode(): JsonNode;
    private createConst;
    decodeObj(length: number): ObjectType;
    private decodeObjChunk;
    decodeArr(length: number): ArrayType;
    private decodeArrChunk;
    decodeStr(length: number): StringType;
    private decodeStrChunk;
    decodeBin(length: number): BinaryType;
    private decodeBinChunk;
    private decodeVal;
    private decodeValLiteral;
}
