import { ArrayChunk } from '../../types/rga-array/ArrayChunk';
import { ArrayType } from '../../types/rga-array/ArrayType';
import { BinaryChunk } from '../../types/rga-binary/BinaryChunk';
import { BinaryType } from '../../types/rga-binary/BinaryType';
import { ConstantType } from '../../types/const/ConstantType';
import { DocRootType } from '../../types/lww-doc-root/DocRootType';
import { JsonNode } from '../../types';
import { ObjectType } from '../../types/lww-object/ObjectType';
import { StringChunk } from '../../types/rga-string/StringChunk';
import { StringType } from '../../types/rga-string/StringType';
import { ValueType } from '../../types/lww-value/ValueType';
import type { ITimestamp, IVectorClock } from '../../../json-crdt-patch/clock';
import type { Model } from '../../model';
import type { RootJsonCrdtNode, JsonCrdtNode, ObjectJsonCrdtNode, ArrayJsonCrdtNode, ArrayJsonCrdtChunk, JsonCrdtRgaTombstone, ValueJsonCrdtNode, StringJsonCrdtNode, StringJsonCrdtChunk, ConstantJsonCrdtNode, BinaryJsonCrdtNode, BinaryJsonCrdtChunk, JsonCrdtLogicalTimestamp, JsonCrdtServerTimestamp, JsonCrdtSnapshot } from './types';
export declare class Encoder {
    encode(model: Model): JsonCrdtSnapshot;
    encodeClock(clock: IVectorClock): JsonCrdtLogicalTimestamp[];
    encodeTimestamp(ts: ITimestamp): JsonCrdtLogicalTimestamp | JsonCrdtServerTimestamp;
    encodeRoot(root: DocRootType): RootJsonCrdtNode;
    encodeNode(node: JsonNode): JsonCrdtNode;
    encodeObj(obj: ObjectType): ObjectJsonCrdtNode;
    encodeArr(obj: ArrayType): ArrayJsonCrdtNode;
    encodeArrChunk(chunk: ArrayChunk): ArrayJsonCrdtChunk | JsonCrdtRgaTombstone;
    encodeStr(obj: StringType): StringJsonCrdtNode;
    encodeStrChunk(chunk: StringChunk): StringJsonCrdtChunk | JsonCrdtRgaTombstone;
    encodeBin(obj: BinaryType): BinaryJsonCrdtNode;
    encodeBinChunk(chunk: BinaryChunk): BinaryJsonCrdtChunk | JsonCrdtRgaTombstone;
    encodeVal(obj: ValueType): ValueJsonCrdtNode;
    encodeConst(obj: ConstantType): ConstantJsonCrdtNode;
}
