"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonPatch = void 0;
var JsonPatchDraft_1 = require("./JsonPatchDraft");
var json_1 = require("../../json-patch/codec/json");
var JsonPatch = (function () {
    function JsonPatch(model) {
        this.model = model;
    }
    JsonPatch.prototype.createDraft = function (ops) {
        var draft = new JsonPatchDraft_1.JsonPatchDraft(this.model);
        draft.applyOps(ops);
        return draft;
    };
    JsonPatch.prototype.createCrdtPatch = function (ops) {
        return this.createDraft(ops).patch(this.model.clock);
    };
    JsonPatch.prototype.applyPatch = function (jsonPatch, options) {
        var ops = (0, json_1.decode)(jsonPatch, options);
        var patch = this.createCrdtPatch(ops);
        this.model.clock.tick(patch.span());
        this.model.applyPatch(patch);
    };
    return JsonPatch;
}());
exports.JsonPatch = JsonPatch;
