"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodeApi = void 0;
var Finder_1 = require("./Finder");
var NodeApi = (function () {
    function NodeApi(api, node) {
        this.api = api;
        this.node = node;
    }
    NodeApi.prototype.find = function (path) {
        var finder = new Finder_1.Finder(this.node, this.api);
        return path ? finder.find(path) : finder;
    };
    NodeApi.prototype.val = function (path) {
        return this.find().val(path);
    };
    NodeApi.prototype.str = function (path) {
        return this.find().str(path);
    };
    NodeApi.prototype.bin = function (path) {
        return this.find().bin(path);
    };
    NodeApi.prototype.arr = function (path) {
        return this.find().arr(path);
    };
    NodeApi.prototype.obj = function (path) {
        return this.find().obj(path);
    };
    NodeApi.prototype.commit = function () {
        this.api.commit();
    };
    NodeApi.prototype.toView = function () {
        return this.node.toJson();
    };
    return NodeApi;
}());
exports.NodeApi = NodeApi;
