"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DocRootType = void 0;
var tslib_1 = require("tslib");
var constants_1 = require("../../../json-crdt-patch/constants");
var DocRootType = (function () {
    function DocRootType(doc, id, node) {
        this.doc = doc;
        this.id = id;
        this.node = node;
    }
    DocRootType.prototype.insert = function (op) {
        if (!this.node) {
            this.set(op.id, op.value);
            return null;
        }
        else if (op.id.compare(this.id) > 0) {
            var node = this.node;
            this.set(op.id, op.value);
            return node.id;
        }
        return null;
    };
    DocRootType.prototype.set = function (id, value) {
        var node = this.doc.node(value);
        if (!node)
            return;
        this.id = id;
        this.node = node;
    };
    DocRootType.prototype.toValue = function () {
        return this.node ? this.node.id : constants_1.UNDEFINED_ID;
    };
    DocRootType.prototype.toJson = function () {
        return !this.node ? undefined : this.node.toJson();
    };
    DocRootType.prototype.toString = function (tab) {
        if (tab === void 0) { tab = ''; }
        return this.node ? this.node.toString(tab) : 'undefined';
    };
    DocRootType.prototype.clone = function (doc) {
        return new DocRootType(doc, this.id, this.node ? this.node.clone(doc) : null);
    };
    DocRootType.prototype.children = function () {
        return (0, tslib_1.__generator)(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!this.node) return [3, 2];
                    return [4, this.node.id];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [2];
            }
        });
    };
    return DocRootType;
}());
exports.DocRootType = DocRootType;
