"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayChunk = void 0;
var tslib_1 = require("tslib");
var clock_1 = require("../../../json-crdt-patch/clock");
var ArrayChunk = (function () {
    function ArrayChunk(id, nodes) {
        this.id = id;
        this.nodes = nodes;
        this.left = null;
        this.right = null;
    }
    ArrayChunk.prototype.span = function () {
        return this.deleted || this.nodes.length;
    };
    ArrayChunk.prototype.split = function (time) {
        var newSpan = 1 + time - this.id.time;
        var newId = new clock_1.LogicalTimestamp(this.id.getSessionId(), time + 1);
        if (this.nodes) {
            var newChunkValues = this.nodes.splice(newSpan);
            return new ArrayChunk(newId, newChunkValues);
        }
        else {
            var chunk = new ArrayChunk(newId, undefined);
            chunk.deleted = this.span() - newSpan;
            this.deleted = newSpan;
            return chunk;
        }
    };
    ArrayChunk.prototype.delete = function () {
        this.deleted = this.span();
        delete this.nodes;
    };
    ArrayChunk.prototype.merge = function (values) {
        var _a;
        (_a = this.nodes).push.apply(_a, (0, tslib_1.__spreadArray)([], (0, tslib_1.__read)(values), false));
    };
    ArrayChunk.prototype.clone = function (model) {
        var e_1, _a;
        if (this.nodes) {
            var nodes = [];
            try {
                for (var _b = (0, tslib_1.__values)(this.nodes), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var node = _c.value;
                    nodes.push(node.clone(model));
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return new ArrayChunk(this.id, nodes);
        }
        else {
            var chunk = new ArrayChunk(this.id, undefined);
            chunk.deleted = this.deleted;
            delete this.nodes;
            return chunk;
        }
    };
    ArrayChunk.prototype.toString = function (tab) {
        if (tab === void 0) { tab = ''; }
        var str = "".concat(tab, "ArrayChunk(").concat(this.id.toDisplayString(), ") { ").concat(!this.nodes ? "[".concat(this.deleted || 0, "]") : this.nodes.map(function (val) { return val.toString(); }).join(', '), " }");
        return str;
    };
    return ArrayChunk;
}());
exports.ArrayChunk = ArrayChunk;
