"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepEqual = void 0;
var deepEqual = function (a, b) {
    if (a === b)
        return true;
    if (a && b && typeof a === 'object' && typeof b === 'object') {
        if (a.constructor !== b.constructor)
            return false;
        var length_1, i = void 0, keys = void 0;
        if (Array.isArray(a)) {
            length_1 = a.length;
            if (length_1 !== b.length)
                return false;
            for (i = length_1; i-- !== 0;)
                if (!(0, exports.deepEqual)(a[i], b[i]))
                    return false;
            return true;
        }
        keys = Object.keys(a);
        length_1 = keys.length;
        if (length_1 !== Object.keys(b).length)
            return false;
        for (i = length_1; i-- !== 0;)
            if (b[keys[i]] === undefined)
                return false;
        for (i = length_1; i-- !== 0;) {
            var key = keys[i];
            if (!(0, exports.deepEqual)(a[key], b[key]))
                return false;
        }
        return true;
    }
    return false;
};
exports.deepEqual = deepEqual;
