import { JsonPackExtension } from '../JsonPackExtension';
import { CachedKeyDecoder } from './CachedKeyDecoder';
export declare class Decoder {
    private readonly keyDecoder;
    protected uint8: Uint8Array;
    protected view: DataView;
    protected x: number;
    constructor(keyDecoder?: CachedKeyDecoder);
    getOffset(): number;
    reset(uint8: Uint8Array): void;
    decode(uint8: Uint8Array): unknown;
    protected val(): unknown;
    protected str(size: number): string;
    protected obj(size: number): object;
    protected key(): string;
    protected arr(size: number): unknown[];
    protected bin(size: number): Uint8Array;
    protected ext(size: number): JsonPackExtension;
    protected back(bytes: number): void;
    protected peak(): number;
    protected u8(): number;
    protected u16(): number;
    protected u32(): number;
    protected i8(): number;
    protected i16(): number;
    protected i32(): number;
    protected f32(): number;
    protected f64(): number;
    decodeOneLevel(uint8: Uint8Array): unknown;
    protected valOneLevel(): unknown;
    protected primitive(): unknown;
    protected skip(length: number): number;
    valSkip(): number;
    protected arrSkip(size: number): number;
    protected objSkip(size: number): number;
}
