"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EncoderFull = void 0;
var tslib_1 = require("tslib");
var isUint8Array_1 = require("../../util/isUint8Array");
var v4_1 = require("../Encoder/v4");
var JsonPackExtension_1 = require("../JsonPackExtension");
var JsonPackValue_1 = require("../JsonPackValue");
var EncoderFull = (function (_super) {
    (0, tslib_1.__extends)(EncoderFull, _super);
    function EncoderFull() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EncoderFull.prototype.encodeAny = function (json) {
        switch (json) {
            case null:
                return this.u8(0xc0);
            case false:
                return this.u8(0xc2);
            case true:
                return this.u8(0xc3);
        }
        if (json instanceof Array)
            return this.encodeArray(json);
        switch (typeof json) {
            case 'number':
                return this.encodeNumber(json);
            case 'string':
                return this.encodeString(json);
            case 'object': {
                if (json instanceof JsonPackValue_1.JsonPackValue)
                    return this.buf(json.buf, json.buf.byteLength);
                if (json instanceof JsonPackExtension_1.JsonPackExtension)
                    return this.encodeExt(json);
                if ((0, isUint8Array_1.isUint8Array)(json))
                    return this.encodeBinary(json);
                return this.encodeObject(json);
            }
        }
    };
    return EncoderFull;
}(v4_1.Encoder));
exports.EncoderFull = EncoderFull;
