"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.xRemove = void 0;
var tslib_1 = require("tslib");
var op_1 = require("../../json-patch/op");
var json_pointer_1 = require("../../json-pointer");
var util_1 = require("./util");
var json_1 = require("../../json-patch/codec/json");
var xRemove = function (add, op) {
    if ((0, json_pointer_1.isRoot)(add.path))
        return null;
    if ((0, json_pointer_1.isRoot)(op.path))
        return op;
    var lastIndex = add.path.length - 1;
    var lastStep = add.path[lastIndex];
    var isLastStepNumberLike = (0, json_pointer_1.isValidIndex)(lastStep);
    if (op instanceof op_1.OpRemove && (0, json_pointer_1.isPathEqual)(add.path, op.path) && isLastStepNumberLike)
        return null;
    if (isLastStepNumberLike) {
        var newPath = (0, util_1.lowerArrayPath)(add.path, op.path);
        var newFrom = op.from ? (0, util_1.lowerArrayPath)(add.path, op.from) : undefined;
        if (newPath || newFrom) {
            var operation = (0, tslib_1.__assign)((0, tslib_1.__assign)({}, op.toJson()), { path: newPath ? (0, json_pointer_1.formatJsonPointer)(newPath) : op.path });
            if (newFrom)
                operation.from = newFrom;
            return (0, json_1.operationToOp)(operation, {});
        }
    }
    return op;
};
exports.xRemove = xRemove;
