"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyPatch = exports.applyOps = exports.applyOp = void 0;
var clone_1 = require("../../json-clone/clone");
var json_1 = require("../codec/json");
function applyOp(doc, op, mutate) {
    if (!mutate)
        doc = (0, clone_1.clone)(doc);
    return op.apply(doc);
}
exports.applyOp = applyOp;
function applyOps(doc, ops, mutate) {
    if (!mutate)
        doc = (0, clone_1.clone)(doc);
    var res = [];
    var length = ops.length;
    for (var i = 0; i < length; i++) {
        var opResult = ops[i].apply(doc);
        doc = opResult.doc;
        res.push(opResult);
    }
    return { doc: doc, res: res };
}
exports.applyOps = applyOps;
function applyPatch(doc, patch, options) {
    if (!options.mutate)
        doc = (0, clone_1.clone)(doc);
    var res = [];
    var length = patch.length;
    for (var i = 0; i < length; i++) {
        var op = (0, json_1.operationToOp)(patch[i], options);
        var opResult = op.apply(doc);
        doc = opResult.doc;
        res.push(opResult);
    }
    return { doc: doc, res: res };
}
exports.applyPatch = applyPatch;
