"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$add = exports.$$add = void 0;
var codegen_1 = require("../../../util/codegen");
var findRef_1 = require("../../../json-pointer/codegen/findRef");
var $$add = function (op) {
    var find = (0, findRef_1.$findRef)(op.path);
    var js = "\n(function(find, path){\n  return function(doc){\n    var value = ".concat(JSON.stringify(op.value), ";\n    var f = find(doc);\n    var obj = f.obj, key = f.key, val = f.val;\n    if (!obj) doc = value;\n    else if (typeof key === 'string') obj[key] = value;\n    else {\n      var length = obj.length;\n      if (key < length) obj.splice(key, 0, value);\n      else if (key > length) throw new Error('INVALID_INDEX');\n      else obj.push(value);\n    }\n    return doc;\n  };\n})");
    return {
        deps: [find, op.path],
        js: js,
    };
};
exports.$$add = $$add;
var $add = function (op) { return (0, codegen_1.compileClosure)((0, exports.$$add)(op)); };
exports.$add = $add;
