"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMatcherDefault = exports.isElementNode = exports.isTextNode = void 0;
var isArray = Array.isArray;
var isTextNode = function (node) {
    return !!node && typeof node === 'object' && typeof node.text === 'string';
};
exports.isTextNode = isTextNode;
var isElementNode = function (node) {
    return !!node && typeof node === 'object' && isArray(node.children);
};
exports.isElementNode = isElementNode;
var createMatcherDefault = function (pattern, ignoreCase) {
    var reg = new RegExp(pattern, ignoreCase ? 'i' : undefined);
    return function (value) { return reg.test(value); };
};
exports.createMatcherDefault = createMatcherDefault;
