"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$findRef = exports.$$findRef = void 0;
var codegen_1 = require("../../util/codegen");
var hasOwnProperty_1 = require("../../util/hasOwnProperty");
var $$findRef = function (path) {
    if (!path.length) {
        return {
            deps: [],
            js: "(function(){return function(val){return {val:val}}})",
        };
    }
    var loop = '';
    for (var i = 0; i < path.length; i++) {
        var key = JSON.stringify(path[i]);
        loop += "\n      obj = val;\n      key = ".concat(key, ";\n      if (obj instanceof Array) {\n        var length = obj.length;\n        if (key === '-') key = length;\n        else {\n          var key2 = ").concat(~~path[i], ";\n          ").concat(String(~~path[i]) !== String(path[i]) ? "if ('' + key2 !== key) throw new Error('INVALID_INDEX');" : '', "\n          ").concat(~~path[i] < 0 ? "throw new Error('INVALID_INDEX');" : '', "\n          key = key2;\n        }\n        val = obj[key];\n      } else if (typeof obj === 'object' && !!obj) {\n        val = hasOwnProperty(obj, key) ? obj[key] : undefined;\n      } else throw new Error('NOT_FOUND');\n    ");
    }
    var js = "(function(hasOwnProperty, path){\n    return function(val) {\n      var obj, key;\n      ".concat(loop, "\n      return {val:val, obj:obj, key:key};\n    };\n  })");
    return {
        deps: [hasOwnProperty_1.hasOwnProperty, path],
        js: js,
    };
};
exports.$$findRef = $$findRef;
var $findRef = function (path) { return (0, codegen_1.compileClosure)((0, exports.$$findRef)(path)); };
exports.$findRef = $findRef;
