"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.get = void 0;
var hasOwnProperty_1 = require("../util/hasOwnProperty");
var get = function (val, path) {
    var pathLength = path.length;
    var key;
    if (!pathLength)
        return val;
    for (var i = 0; i < pathLength; i++) {
        key = path[i];
        if (val instanceof Array) {
            var length_1 = val.length;
            if (key === '-')
                return undefined;
            var key2 = ~~key;
            if ('' + key2 !== key)
                return undefined;
            key = key2;
            if (key < 0)
                return undefined;
            val = val[key];
        }
        else if (typeof val === 'object') {
            if (!val || !(0, hasOwnProperty_1.hasOwnProperty)(val, key))
                return undefined;
            val = val[key];
        }
        else
            return undefined;
    }
    return val;
};
exports.get = get;
