"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonRpc2CodecJson = void 0;
var JsonRpc2CodecJson = (function () {
    function JsonRpc2CodecJson() {
    }
    JsonRpc2CodecJson.prototype.decode = function (data) {
        return Array.isArray(data) ? data : [data];
    };
    JsonRpc2CodecJson.prototype.encodeError = function (error, id) {
        var message = {
            jsonrpc: '2.0',
            id: id,
            error: error,
        };
        return message;
    };
    JsonRpc2CodecJson.prototype.encodeParseError = function () {
        return this.encodeError({
            code: -32700,
            message: 'Parse error',
        }, null);
    };
    JsonRpc2CodecJson.prototype.encodeInvalidRequestError = function (id) {
        return this.encodeError({
            code: -32600,
            message: 'Invalid Request',
        }, id);
    };
    JsonRpc2CodecJson.prototype.encodeMethodNotFoundError = function (id) {
        return this.encodeError({
            code: -32601,
            message: 'Method not found',
        }, id);
    };
    JsonRpc2CodecJson.prototype.encodeInvalidParamsError = function (id) {
        return this.encodeError({
            code: -32602,
            message: 'Invalid params',
        }, id);
    };
    JsonRpc2CodecJson.prototype.encodeInternalError = function (id) {
        return this.encodeError({
            code: -32603,
            message: 'Internal error',
        }, id);
    };
    JsonRpc2CodecJson.prototype.encodeResponse = function (id, result) {
        var responseMessage = {
            jsonrpc: '2.0',
            id: id,
            result: result,
        };
        return responseMessage;
    };
    JsonRpc2CodecJson.prototype.encodeBatch = function (messages) {
        return messages;
    };
    return JsonRpc2CodecJson;
}());
exports.JsonRpc2CodecJson = JsonRpc2CodecJson;
