"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryNotificationMessage = void 0;
var tslib_1 = require("tslib");
var header_1 = require("../../codec/binary/header");
var nominal_1 = require("../nominal");
var BinaryNotificationMessage = (function (_super) {
    (0, tslib_1.__extends)(BinaryNotificationMessage, _super);
    function BinaryNotificationMessage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BinaryNotificationMessage.prototype.size = function () {
        var dataSize = this.data ? this.data.byteLength : 0;
        return (0, header_1.getHeaderSize)(dataSize) + 1 + this.method.length + dataSize;
    };
    BinaryNotificationMessage.prototype.writeCompact = function (encoder) {
        var data = this.data;
        var dataSize = data ? data.byteLength : 0;
        if (!dataSize) {
            encoder.encodeArrayHeader(1);
            encoder.encodeAsciiString(this.method);
            return;
        }
        encoder.encodeArrayHeader(2);
        encoder.encodeAsciiString(this.method);
        encoder.buf(data, dataSize);
    };
    return BinaryNotificationMessage;
}(nominal_1.NotificationMessage));
exports.BinaryNotificationMessage = BinaryNotificationMessage;
