"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryRequestCompleteMessage = void 0;
var tslib_1 = require("tslib");
var header_1 = require("../../codec/binary/header");
var nominal_1 = require("../nominal");
var BinaryRequestCompleteMessage = (function (_super) {
    (0, tslib_1.__extends)(BinaryRequestCompleteMessage, _super);
    function BinaryRequestCompleteMessage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BinaryRequestCompleteMessage.prototype.size = function () {
        var dataSize = this.data ? this.data.byteLength : 0;
        return (0, header_1.getHeaderSize)(dataSize) + 2 + 1 + this.method.length + dataSize;
    };
    BinaryRequestCompleteMessage.prototype.writeCompact = function (encoder) {
        var data = this.data;
        var dataSize = data ? data.byteLength : 0;
        if (!dataSize) {
            encoder.encodeArrayHeader(2);
            encoder.encodeUnsignedInteger(this.id);
            encoder.encodeAsciiString(this.method);
            return;
        }
        encoder.encodeArrayHeader(3);
        encoder.encodeUnsignedInteger(this.id);
        encoder.encodeAsciiString(this.method);
        encoder.buf(data, dataSize);
    };
    return BinaryRequestCompleteMessage;
}(nominal_1.RequestCompleteMessage));
exports.BinaryRequestCompleteMessage = BinaryRequestCompleteMessage;
