"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryRequestDataMessage = void 0;
var tslib_1 = require("tslib");
var header_1 = require("../../codec/binary/header");
var nominal_1 = require("../nominal");
var BinaryRequestDataMessage = (function (_super) {
    (0, tslib_1.__extends)(BinaryRequestDataMessage, _super);
    function BinaryRequestDataMessage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BinaryRequestDataMessage.prototype.size = function () {
        var dataSize = this.data ? this.data.byteLength : 0;
        return (0, header_1.getHeaderSize)(dataSize) + 2 + 1 + this.method.length + dataSize;
    };
    BinaryRequestDataMessage.prototype.writeCompact = function (encoder) {
        var data = this.data;
        var dataSize = data ? data.byteLength : 0;
        if (!dataSize) {
            encoder.encodeArrayHeader(3);
            encoder.encodeUnsignedInteger(this.id);
            encoder.u8(0);
            encoder.encodeAsciiString(this.method);
            return;
        }
        encoder.encodeArrayHeader(4);
        encoder.encodeUnsignedInteger(this.id);
        encoder.u8(0);
        encoder.encodeAsciiString(this.method);
        encoder.buf(data, dataSize);
    };
    return BinaryRequestDataMessage;
}(nominal_1.RequestDataMessage));
exports.BinaryRequestDataMessage = BinaryRequestDataMessage;
