"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryResponseCompleteMessage = void 0;
var tslib_1 = require("tslib");
var header_1 = require("../../codec/binary/header");
var nominal_1 = require("../nominal");
var BinaryResponseCompleteMessage = (function (_super) {
    (0, tslib_1.__extends)(BinaryResponseCompleteMessage, _super);
    function BinaryResponseCompleteMessage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BinaryResponseCompleteMessage.prototype.size = function () {
        var dataSize = this.data ? this.data.byteLength : 0;
        return (0, header_1.getHeaderSize)(dataSize) + 2 + dataSize;
    };
    BinaryResponseCompleteMessage.prototype.writeCompact = function (encoder) {
        var data = this.data;
        var dataSize = data ? data.byteLength : 0;
        if (!dataSize) {
            encoder.encodeArrayHeader(2);
            encoder.u8(0);
            encoder.encodeUnsignedInteger(this.id);
            return;
        }
        encoder.encodeArrayHeader(3);
        encoder.u8(0);
        encoder.encodeUnsignedInteger(this.id);
        encoder.buf(data, dataSize);
    };
    return BinaryResponseCompleteMessage;
}(nominal_1.ResponseCompleteMessage));
exports.BinaryResponseCompleteMessage = BinaryResponseCompleteMessage;
