"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonRequestDataMessage = void 0;
var tslib_1 = require("tslib");
var nominal_1 = require("../nominal");
var JsonRequestDataMessage = (function (_super) {
    (0, tslib_1.__extends)(JsonRequestDataMessage, _super);
    function JsonRequestDataMessage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    JsonRequestDataMessage.prototype.toValue = function () {
        return this.data === undefined ? undefined : JSON.parse(this.data);
    };
    JsonRequestDataMessage.prototype.toCompact = function () {
        var value = this.toValue();
        return value === undefined ? [this.id, 0, this.method] : [this.id, 0, this.method, value];
    };
    JsonRequestDataMessage.prototype.toCompactJson = function () {
        var data = this.data;
        if (data === undefined)
            return ('[' + this.id + ',0,"' + this.method + '",' + data + ']');
        return ('[' + this.id + ',0,"' + this.method + '"]');
    };
    return JsonRequestDataMessage;
}(nominal_1.RequestDataMessage));
exports.JsonRequestDataMessage = JsonRequestDataMessage;
