import { RpcServer } from './RpcServer';
import type { Call } from './RpcApiCaller';
import { JsonNotificationMessage } from '../messages/json/JsonNotificationMessage';
import { JsonRequestUnsubscribeMessage } from '../messages/json/JsonRequestUnsubscribeMessage';
import { JsonResponseCompleteMessage } from '../messages/json/JsonResponseCompleteMessage';
import { JsonResponseDataMessage } from '../messages/json/JsonResponseDataMessage';
import { JsonResponseErrorMessage } from '../messages/json/JsonResponseErrorMessage';
export declare class RpcServerJson<Ctx = unknown> extends RpcServer<Ctx> {
    protected notifMessage(method: string, data: unknown): JsonNotificationMessage;
    protected resCompleteMessage(id: number, data: unknown): JsonResponseCompleteMessage;
    protected resDataMessage(id: number, data: unknown): JsonResponseDataMessage;
    protected resErrorMessage(id: number, data: unknown): JsonResponseErrorMessage;
    protected reqUnsubscribeMessage(id: number): JsonRequestUnsubscribeMessage;
    protected createStaticCall(name: string, request: unknown, ctx: Ctx): Promise<unknown>;
    protected createCall(name: string, ctx: Ctx): Call<unknown, unknown>;
}
