"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RpcServerJson = void 0;
var tslib_1 = require("tslib");
var RpcServer_1 = require("./RpcServer");
var json_brand_1 = require("../../../json-brand");
var JsonNotificationMessage_1 = require("../messages/json/JsonNotificationMessage");
var JsonRequestUnsubscribeMessage_1 = require("../messages/json/JsonRequestUnsubscribeMessage");
var JsonResponseCompleteMessage_1 = require("../messages/json/JsonResponseCompleteMessage");
var JsonResponseDataMessage_1 = require("../messages/json/JsonResponseDataMessage");
var JsonResponseErrorMessage_1 = require("../messages/json/JsonResponseErrorMessage");
var stringify = json_brand_1.JSON.stringify;
var RpcServerJson = (function (_super) {
    (0, tslib_1.__extends)(RpcServerJson, _super);
    function RpcServerJson() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RpcServerJson.prototype.notifMessage = function (method, data) {
        return new JsonNotificationMessage_1.JsonNotificationMessage(method, stringify(data));
    };
    RpcServerJson.prototype.resCompleteMessage = function (id, data) {
        return new JsonResponseCompleteMessage_1.JsonResponseCompleteMessage(id, data);
    };
    RpcServerJson.prototype.resDataMessage = function (id, data) {
        return new JsonResponseDataMessage_1.JsonResponseDataMessage(id, data);
    };
    RpcServerJson.prototype.resErrorMessage = function (id, data) {
        return new JsonResponseErrorMessage_1.JsonResponseErrorMessage(id, stringify(data));
    };
    RpcServerJson.prototype.reqUnsubscribeMessage = function (id) {
        return new JsonRequestUnsubscribeMessage_1.JsonRequestUnsubscribeMessage(id);
    };
    RpcServerJson.prototype.createStaticCall = function (name, request, ctx) {
        return this.caller.callJson(name, request, ctx);
    };
    RpcServerJson.prototype.createCall = function (name, ctx) {
        var _this = this;
        var streamCallback = function (method, ctx, req$) { return method.callJson$(ctx, req$); };
        return this.caller.createCall(name, ctx, function (name, req, ctx) { return _this.caller.callJson(name, req, ctx); }, streamCallback);
    };
    return RpcServerJson;
}(RpcServer_1.RpcServer));
exports.RpcServerJson = RpcServerJson;
