"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RpcServerMsgPack = void 0;
var tslib_1 = require("tslib");
var RpcServer_1 = require("./RpcServer");
var binary_1 = require("../messages/binary");
var util_1 = require("../../../json-pack/util");
var RpcServerMsgPack = (function (_super) {
    (0, tslib_1.__extends)(RpcServerMsgPack, _super);
    function RpcServerMsgPack() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RpcServerMsgPack.prototype.notifMessage = function (method, data) {
        return new binary_1.BinaryNotificationMessage(method, (0, util_1.encodeFull)(data));
    };
    RpcServerMsgPack.prototype.resCompleteMessage = function (id, data) {
        return new binary_1.BinaryResponseCompleteMessage(id, data);
    };
    RpcServerMsgPack.prototype.resDataMessage = function (id, data) {
        return new binary_1.BinaryResponseDataMessage(id, data);
    };
    RpcServerMsgPack.prototype.resErrorMessage = function (id, data) {
        return new binary_1.BinaryResponseErrorMessage(id, (0, util_1.encodeFull)(data));
    };
    RpcServerMsgPack.prototype.reqUnsubscribeMessage = function (id) {
        return new binary_1.BinaryRequestUnsubscribeMessage(id);
    };
    RpcServerMsgPack.prototype.createStaticCall = function (name, request, ctx) {
        return this.caller.callMsgPack(name, request, ctx);
    };
    RpcServerMsgPack.prototype.createCall = function (name, ctx) {
        var _this = this;
        var streamCallback = function (method, ctx, req$) { return method.callMsgPack$(ctx, req$); };
        return this.caller.createCall(name, ctx, function (name, req, ctx) { return _this.caller.callMsgPack(name, req, ctx); }, streamCallback);
    };
    return RpcServerMsgPack;
}(RpcServer_1.RpcServer));
exports.RpcServerMsgPack = RpcServerMsgPack;
