"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.wrapMethod = exports.RpcMethodStreamingWrap = exports.RpcMethodStaticWrap = void 0;
var tslib_1 = require("tslib");
var json_brand_1 = require("../../../json-brand");
var util_1 = require("../../../json-pack/util");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var RpcMethodStaticWrap = (function () {
    function RpcMethodStaticWrap(method, types) {
        var _this = this;
        this.isStreaming = false;
        this.req = method.req || '';
        this.res = method.res || '';
        this.validate = method.validate ? method.validate.bind(method) : undefined;
        this.onPreCall = method.onPreCall ? method.onPreCall.bind(method) : undefined;
        this.pretty = !!method.pretty;
        var call = method.call ? method.call.bind(method) : undefined;
        var callJson = method.callJson ? method.callJson.bind(method) : undefined;
        var callMsgPack = method.callMsgPack ? method.callMsgPack.bind(method) : undefined;
        if (call)
            this.call = call;
        else if (callJson) {
            this.call = function (ctx, request) { return (0, tslib_1.__awaiter)(_this, void 0, void 0, function () { var _a, _b; return (0, tslib_1.__generator)(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _b = (_a = json_brand_1.JSON).parse;
                        return [4, callJson(ctx, request)];
                    case 1: return [2, _b.apply(_a, [_c.sent()])];
                }
            }); }); };
        }
        else if (callMsgPack) {
            this.call = function (ctx, request) { return (0, tslib_1.__awaiter)(_this, void 0, void 0, function () { var _a; return (0, tslib_1.__generator)(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = util_1.decode;
                        return [4, callMsgPack(ctx, request)];
                    case 1: return [2, _a.apply(void 0, [_b.sent()])];
                }
            }); }); };
        }
        else
            throw new Error('No call method defined.');
        if (callJson) {
            this.callJson = callJson;
        }
        else {
            var serializer_1 = this.res && types && types.hasType(this.res) ? types.getJsonSerializer(this.res) : json_brand_1.JSON.stringify;
            this.callJson = function (ctx, request) { return (0, tslib_1.__awaiter)(_this, void 0, void 0, function () { var _a; return (0, tslib_1.__generator)(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = serializer_1;
                        return [4, this.call(ctx, request)];
                    case 1: return [2, _a.apply(void 0, [_b.sent()])];
                }
            }); }); };
        }
        if (callMsgPack) {
            this.callMsgPack = callMsgPack;
        }
        else {
            var serializer_2 = this.res && types && types.hasType(this.res) ? types.getMsgPackEncoder(this.res) : util_1.encodeFull;
            this.callMsgPack = function (ctx, request) { return (0, tslib_1.__awaiter)(_this, void 0, void 0, function () { var _a; return (0, tslib_1.__generator)(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = serializer_2;
                        return [4, this.call(ctx, request)];
                    case 1: return [2, _a.apply(void 0, [_b.sent()])];
                }
            }); }); };
        }
        this.call$ = function (ctx, request$) {
            return (0, rxjs_1.from)((function () { return (0, tslib_1.__awaiter)(_this, void 0, void 0, function () {
                var request;
                return (0, tslib_1.__generator)(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, (0, rxjs_1.firstValueFrom)(request$)];
                        case 1:
                            request = _a.sent();
                            return [4, this.call(ctx, request)];
                        case 2: return [2, _a.sent()];
                    }
                });
            }); })());
        };
        this.callJson$ = function (ctx, request$) {
            return (0, rxjs_1.from)((function () { return (0, tslib_1.__awaiter)(_this, void 0, void 0, function () {
                var request;
                return (0, tslib_1.__generator)(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, (0, rxjs_1.firstValueFrom)(request$)];
                        case 1:
                            request = _a.sent();
                            return [4, this.callJson(ctx, request)];
                        case 2: return [2, _a.sent()];
                    }
                });
            }); })());
        };
        this.callMsgPack$ = function (ctx, request$) {
            return (0, rxjs_1.from)((function () { return (0, tslib_1.__awaiter)(_this, void 0, void 0, function () {
                var request;
                return (0, tslib_1.__generator)(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, (0, rxjs_1.firstValueFrom)(request$)];
                        case 1:
                            request = _a.sent();
                            return [4, this.callMsgPack(ctx, request)];
                        case 2: return [2, _a.sent()];
                    }
                });
            }); })());
        };
    }
    return RpcMethodStaticWrap;
}());
exports.RpcMethodStaticWrap = RpcMethodStaticWrap;
var RpcMethodStreamingWrap = (function () {
    function RpcMethodStreamingWrap(method, types) {
        var _this = this;
        this.isStreaming = true;
        this.req = method.req || '';
        this.res = method.res || '';
        this.validate = method.validate ? method.validate.bind(method) : undefined;
        this.onPreCall = method.onPreCall ? method.onPreCall.bind(method) : undefined;
        this.preCallBufferSize = method.preCallBufferSize;
        this.pretty = !!method.pretty;
        var call$ = method.call$ ? method.call$.bind(method) : undefined;
        var callJson$ = method.callJson$ ? method.callJson$.bind(method) : undefined;
        var callMsgPack$ = method.callMsgPack$ ? method.callMsgPack$.bind(method) : undefined;
        if (call$)
            this.call$ = call$;
        else if (callJson$) {
            this.call$ = function (ctx, request) { return callJson$(ctx, request).pipe((0, operators_1.map)(function (json) { return json_brand_1.JSON.parse(json); })); };
        }
        else if (callMsgPack$) {
            this.call$ = function (ctx, request) { return callMsgPack$(ctx, request).pipe((0, operators_1.map)(function (blob) { return (0, util_1.decode)(blob); })); };
        }
        else
            throw new Error('No call method defined.');
        if (callJson$) {
            this.callJson$ = callJson$;
        }
        else {
            var serializer_3 = this.res && types && types.hasType(this.res) ? types.getJsonSerializer(this.res) : json_brand_1.JSON.stringify;
            this.callJson$ = function (ctx, request) { return _this.call$(ctx, request).pipe((0, operators_1.map)(function (res) { return serializer_3(res); })); };
        }
        if (callMsgPack$) {
            this.callMsgPack$ = callMsgPack$;
        }
        else {
            var serializer_4 = this.res && types && types.hasType(this.res) ? types.getMsgPackEncoder(this.res) : util_1.encodeFull;
            this.callMsgPack$ = function (ctx, request) { return _this.call$(ctx, request).pipe((0, operators_1.map)(function (res) { return serializer_4(res); })); };
        }
        this.call = function (ctx, request) { return (0, rxjs_1.firstValueFrom)(_this.call$(ctx, (0, rxjs_1.of)(request))); };
        this.callJson = function (ctx, request) { return (0, rxjs_1.firstValueFrom)(_this.callJson$(ctx, (0, rxjs_1.of)(request))); };
        this.callMsgPack = function (ctx, request) { return (0, rxjs_1.firstValueFrom)(_this.callMsgPack$(ctx, (0, rxjs_1.of)(request))); };
    }
    return RpcMethodStreamingWrap;
}());
exports.RpcMethodStreamingWrap = RpcMethodStreamingWrap;
var wrapMethod = function (method, types) {
    return method.isStreaming
        ? new RpcMethodStreamingWrap(method, types)
        : new RpcMethodStaticWrap(method, types);
};
exports.wrapMethod = wrapMethod;
