"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.subscribeCompleteObserver = void 0;
var microtask_1 = require("./microtask");
function subscribeCompleteObserver(observable, observer) {
    var completed = false;
    var completeCalled = false;
    var tasks = 0;
    return observable.subscribe({
        next: function (value) {
            tasks++;
            (0, microtask_1.microtask)(function () {
                tasks--;
                if (completed && !tasks) {
                    completeCalled = true;
                    observer.complete(value, true);
                }
                else {
                    observer.next(value);
                }
            });
        },
        error: function (error) {
            if (!tasks)
                observer.error(error);
            else
                (0, microtask_1.microtask)(function () {
                    observer.error(error);
                });
        },
        complete: function () {
            completed = true;
            if (completeCalled)
                return;
            if (!tasks)
                observer.complete(undefined, false);
            else {
                (0, microtask_1.microtask)(function () {
                    if (completeCalled)
                        return;
                    observer.complete(undefined, false);
                });
            }
        },
    });
}
exports.subscribeCompleteObserver = subscribeCompleteObserver;
