"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.subscribeSyncObserver = void 0;
var microtask_1 = require("./microtask");
function subscribeSyncObserver(observable, observer) {
    var completed = false;
    var buffer = [];
    var flush = function () {
        if (!buffer.length)
            return;
        observer.next(buffer, completed);
        buffer = [];
    };
    return observable.subscribe({
        next: function (data) {
            buffer.push(data);
            if (buffer.length === 1)
                (0, microtask_1.microtask)(flush);
        },
        error: function (error) {
            flush();
            observer.error(error);
        },
        complete: function () {
            completed = true;
            flush();
            observer.complete();
        },
    });
}
exports.subscribeSyncObserver = subscribeSyncObserver;
