"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createConnectionContext = void 0;
var createConnectionContext = function (req, res) {
    var ip = req.getHeader('x-forwarded-for') ||
        req.getHeader('x-real-ip') ||
        Buffer.from(res.getRemoteAddressAsText()).toString('utf8');
    var token = req.getHeader('authorization') || '';
    if (!token) {
        var query = req.getQuery();
        var params = new URLSearchParams(query);
        token = params.get('access_token') || '';
        if (!token)
            token = params.get('token') || '';
    }
    if (!token) {
        var secWebSocketProtocol = String(req.getHeader('sec-websocket-protocol')) || '';
        if (secWebSocketProtocol) {
            var protocols = secWebSocketProtocol.split(',');
            var length_1 = protocols.length;
            for (var i = 0; i < length_1; i++) {
                var protocol = protocols[i].trim();
                if (protocol.indexOf('X-Authorization=') === 0) {
                    protocol = protocol.substr('X-Authorization='.length);
                    if (protocol) {
                        token = Buffer.from(protocol).toString('base64');
                        break;
                    }
                }
            }
        }
    }
    return { ip: ip, token: token };
};
exports.createConnectionContext = createConnectionContext;
