"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeSseAndNdjsonHeaders = exports.parsePayload = void 0;
var parsePayload = function (ctx, payload) {
    if (typeof payload === 'string') {
        ctx.payloadSize = payload.length;
        return JSON.parse(payload || 'null');
    }
    else {
        ctx.payloadSize = payload.byteLength;
        var str = payload.toString('utf8') || 'null';
        return JSON.parse(str);
    }
};
exports.parsePayload = parsePayload;
var AccessControlAllowOrigin = Buffer.from('Access-Control-Allow-Origin');
var AccessControlAllowOriginAllowAll = Buffer.from('*');
var AccessControlAllowCredentials = Buffer.from('Access-Control-Allow-Credentials');
var AccessControlAllowCredentialsTrue = Buffer.from('true');
var ContentType = Buffer.from('Content-Type');
var ContentTypeTextEventStream = Buffer.from('text/event-stream');
var CacheControl = Buffer.from('Cache-Control');
var CacheControlNoCache = Buffer.from('no-cache');
var Connection = Buffer.from('Connection');
var ConnectionKeepAlive = Buffer.from('keep-alive');
var writeSseAndNdjsonHeaders = function (res, origin) {
    if (origin) {
        res.writeHeader(AccessControlAllowOrigin, AccessControlAllowOriginAllowAll);
        res.writeHeader(AccessControlAllowCredentials, AccessControlAllowCredentialsTrue);
    }
    res.writeHeader(ContentType, ContentTypeTextEventStream);
    res.writeHeader(CacheControl, CacheControlNoCache);
    res.writeHeader(Connection, ConnectionKeepAlive);
};
exports.writeSseAndNdjsonHeaders = writeSseAndNdjsonHeaders;
