"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createConnectionContext = void 0;
var url_1 = require("url");
var createConnectionContext = function (req) {
    var ip = (typeof req.headers['x-forwarded-for'] === 'string' ? req.headers['x-forwarded-for'] : '') ||
        (typeof req.headers['x-real-ip'] === 'string' ? req.headers['x-real-ip'] : '') ||
        req.socket.remoteAddress ||
        '';
    var token = req.headers['authorization'] || '';
    if (!token && req.url) {
        var url = new url_1.URL(req.url);
        var params = new URLSearchParams(url.search);
        token = params.get('access_token') || '';
        if (!token)
            token = params.get('token') || '';
    }
    if (!token && typeof req.headers['sec-websocket-protocol'] === 'string') {
        var secWebSocketProtocol = req.headers['sec-websocket-protocol'];
        if (secWebSocketProtocol) {
            var protocols = secWebSocketProtocol.split(',');
            var length_1 = protocols.length;
            for (var i = 0; i < length_1; i++) {
                var protocol = protocols[i].trim();
                if (protocol.indexOf('X-Authorization=') === 0) {
                    protocol = protocol.substring('X-Authorization='.length);
                    if (protocol) {
                        token = Buffer.from(protocol).toString('base64');
                        break;
                    }
                }
            }
        }
    }
    return { ip: ip, token: token };
};
exports.createConnectionContext = createConnectionContext;
