"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BufferSubject = void 0;
var tslib_1 = require("tslib");
var rxjs_1 = require("rxjs");
var BufferSubject = (function (_super) {
    (0, tslib_1.__extends)(BufferSubject, _super);
    function BufferSubject(bufferSize) {
        var _this = _super.call(this) || this;
        _this.bufferSize = bufferSize;
        _this.buffer = [];
        _this.isBuffering = true;
        return _this;
    }
    BufferSubject.prototype._subscribe = function (subscriber) {
        this._throwIfClosed();
        var subscription = this._innerSubscribe(subscriber);
        var buffer = this.buffer;
        for (var i = 0; i < buffer.length && !subscriber.closed; i += 1) {
            subscriber.next(buffer[i]);
        }
        this._checkFinalizedStatuses(subscriber);
        return subscription;
    };
    BufferSubject.prototype.next = function (value) {
        if (this.isBuffering) {
            if (this.buffer.length >= this.bufferSize) {
                this.error(new Error('BufferSubjectOverflow'));
                return;
            }
            this.buffer.push(value);
        }
        _super.prototype.next.call(this, value);
    };
    BufferSubject.prototype.flush = function () {
        this.isBuffering = false;
        this.buffer = [];
    };
    return BufferSubject;
}(rxjs_1.Subject));
exports.BufferSubject = BufferSubject;
