"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsExpression = void 0;
var tslib_1 = require("tslib");
var JsExpression = (function () {
    function JsExpression(expression) {
        this.expression = expression;
        this._wasUsed = false;
        this._listeners = [];
    }
    Object.defineProperty(JsExpression.prototype, "wasUsed", {
        get: function () {
            return this._wasUsed;
        },
        enumerable: false,
        configurable: true
    });
    JsExpression.prototype.use = function () {
        var e_1, _a;
        if (this._wasUsed)
            return this._expression;
        this._wasUsed = true;
        var expression = (this._expression = this.expression());
        try {
            for (var _b = (0, tslib_1.__values)(this._listeners), _c = _b.next(); !_c.done; _c = _b.next()) {
                var listener = _c.value;
                listener(expression);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return expression;
    };
    JsExpression.prototype.chain = function (use) {
        var _this = this;
        return new JsExpression(function () { return use(_this.use()); });
    };
    JsExpression.prototype.addListener = function (listener) {
        this._listeners.push(listener);
    };
    return JsExpression;
}());
exports.JsExpression = JsExpression;
