"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.wordWrap = void 0;
var tslib_1 = require("tslib");
var lineMap = function (line) {
    return line.slice(-1) === '\n' ? line.slice(0, line.length - 1).replace(/[ \t]*$/gm, '') : line;
};
var lineReduce = function (acc, line) {
    acc.push.apply(acc, (0, tslib_1.__spreadArray)([], (0, tslib_1.__read)(line.split('\n')), false));
    return acc;
};
var wordWrap = function (str, options) {
    if (options === void 0) { options = {}; }
    if (!str)
        return [];
    var width = options.width || 50;
    var regexString = '.{1,' + width + '}([\\s\u200B]+|$)|[^\\s\u200B]+?([\\s\u200B]+|$)';
    var re = new RegExp(regexString, 'g');
    var lines = (str.match(re) || []).map(lineMap).reduce(lineReduce, []);
    return lines;
};
exports.wordWrap = wordWrap;
